/*

    MOUSCLOC.CH

    Include file for programs using MOUSCLOC.LIB.

*/

#DEFINE  K_CLICK         -50
#DEFINE  K_DOUBLECLICK   -51

#DEFINE  MCSET_DSHOW       1
#DEFINE  MCSET_DROW        2
#DEFINE  MCSET_DCOL        3
#DEFINE  MCSET_DCOLOR      4
#DEFINE  MCSET_DFORM       5
#DEFINE  MCSET_TSHOW       6
#DEFINE  MCSET_TROW        7
#DEFINE  MCSET_TCOL        8
#DEFINE  MCSET_TCOLOR      9
#DEFINE  MCSET_TFORM      10
#DEFINE  MCSET_MACTIVE    11
#DEFINE  MCSET_MCURSOR    12
#DEFINE  MCSET_MSPEED     13
#DEFINE  MCSET_EVERCHECK  14
#DEFINE  MCSET_RCURSOR    15
#DEFINE  MCSET_MECURSOR   16
#DEFINE  MCSET_MEREAD     17
#DEFINE  MCSET_SAVER      18
#DEFINE  MCSET_SAVEDELAY  19
#DEFINE  MCSET_KEYRECORD  20

#DEFINE  TA_UNKNOWN        0
#DEFINE  TA_STD            1
#DEFINE  TA_DOUBLECLICK    2
#DEFINE  TA_OUTBOX         3
#DEFINE  TA_RESIZE         4
#DEFINE  TA_CLOSE          5

#DEFINE  SCORE_ROW         0
#DEFINE  SCORE_COL        60

#DEFINE  KPV_TOP           1
#DEFINE  KPV_LEFT          2
#DEFINE  KPV_BOTTOM        3
#DEFINE  KPV_RIGHT         4
#DEFINE  KPV_KEY           5
#DEFINE  KPV_SELECT        6
#DEFINE  KPV_COUNT         6

#DEFINE  MSV_TOP           1
#DEFINE  MSV_LEFT          2
#DEFINE  MSV_BOTTOM        3
#DEFINE  MSV_RIGHT         4
#DEFINE  MSV_MODE          5
#DEFINE  MSV_ENTER         6
#DEFINE  MSV_WIDTH         7
#DEFINE  MSV_TAB           8
#DEFINE  MSV_BUFROW        9
#DEFINE  MSV_BUFCOL       10
#DEFINE  MSV_WINROW       11
#DEFINE  MSV_WINCOL       12
#DEFINE  MSV_GETPOS       13
#DEFINE  MSV_SETPOS       14
#DEFINE  MSV_TYPEOUT      15
#DEFINE  MSV_REFORM       16
#DEFINE  MSV_INSERT       17
#DEFINE  MSV_BOXTOP       18
#DEFINE  MSV_BOXLEFT      19
#DEFINE  MSV_BOXBOTTOM    20
#DEFINE  MSV_BOXRIGHT     21
#DEFINE  MSV_ROWMID       22
#DEFINE  MSV_COLMID       23
#DEFINE  MSV_CLOSE        24
#DEFINE  MSV_RESIZE       25
#DEFINE  MSV_VSCROLL      26
#DEFINE  MSV_HSCROLL      27
#DEFINE  MSV_COUNT        27

#DEFINE  GSV_UPDATED       1
#DEFINE  GSV_LENGTH        2
#DEFINE  GSV_BOXTOP        3
#DEFINE  GSV_BOXLEFT       4
#DEFINE  GSV_BOXBOTTOM     5
#DEFINE  GSV_BOXRIGHT      6
#DEFINE  GSV_BOXCLOSE      7
#DEFINE  GSV_BOXDEFINED    8
#DEFINE  GSV_BUMPTOP       9
#DEFINE  GSV_BUMPBOT      10
#DEFINE  GSV_LASTEXIT     11
#DEFINE  GSV_LASTPOS      12
#DEFINE  GSV_ACTIVEGET    13
#DEFINE  GSV_READVAR      14
#DEFINE  GSV_READPROCNAME 15
#DEFINE  GSV_READPROCLINE 16
#DEFINE  GSV_COUNT        16

#DEFINE  SB_TOP            1
#DEFINE  SB_LEFT           2
#DEFINE  SB_BOTTOM         3
#DEFINE  SB_RIGHT          4
#DEFINE  SB_VERTSCROLL     5
#DEFINE  SB_HORIZSCROLL    6
#DEFINE  SB_CLOSE          7
#DEFINE  SB_RESIZE         8
#DEFINE  SB_DEFINED        9
#DEFINE  SB_SCREEN        10
#DEFINE  SB_VERTMOVE      11
#DEFINE  SB_HORIZMOVE     12
#DEFINE  SB_VSCROLLPOS    13
#DEFINE  SB_VHITTOP       14
#DEFINE  SB_VHITBOTTOM    15
#DEFINE  SB_HSCROLLPOS    16
#DEFINE  SB_HHITLEFT      17
#DEFINE  SB_HHITRIGHT     18
#DEFINE  SB_COUNT         18

#DEFINE  KR_OFF            0
#DEFINE  KR_RECORD         1
#DEFINE  KR_PLAY           2

#TRANSLATE INKEY([<nSec>])        => McInKey(<nSec>)
#TRANSLATE LASTKEY([<nSec>])      => McLastKey(<nSec>)
#TRANSLATE ACHOICE(<args,...>)    => McAChoice(<args>)
#TRANSLATE HACHOICE(<args,...>)   => McHAChoice(<args>)
#TRANSLATE HAWIDTH(<args,...>)    => McHAWidth(<args>)
#TRANSLATE ALERT(<args,...>)      => McAlert(<args>)
#TRANSLATE MEMOEDIT([<args,...>]) => McMemoEdit(<args>)

#COMMAND   READ SAVE              => McReadModal(GetList)
#COMMAND   READ                   => McReadModal(GetList) ; GetList := {}
#COMMAND   CLEAR GETS             => McReadKill(.T.) ; GetList := {}
#TRANSLATE READMODAL(<args,...>)  => McReadModal(<args>)
#TRANSLATE READKILL([<args,...>]) => McReadKill(<args>)
#TRANSLATE UPDATED([<args,...>])  => McUpdated(<args>)

#COMMAND   TICK                            => McClock()

#COMMAND   SET CLOCK ON                    => McSet(MCSET_DSHOW, .T.) ; ;
                                              McSet(MCSET_TSHOW, .T.)
#COMMAND   SET CLOCK OFF                   => McSet(MCSET_DSHOW, .F.) ; ;
                                              McSet(MCSET_TSHOW, .F.)
#COMMAND   SET CLOCK (<x>)                 => McSet(MCSET_DSHOW, <x>) ; ;
                                              McSet(MCSET_TSHOW, <x>)
#COMMAND   SET CLOCK COLOR TO [<*c*>]      => McSet(MCSET_DCOLOR, #<c>) ; ;
                                              McSet(MCSET_TCOLOR, #<c>)
#COMMAND   SET CLOCK COLOR TO (<c>)        => McSet(MCSET_DCOLOR,  <c>) ; ;
                                              McSet(MCSET_TCOLOR,  <c>)

#COMMAND   SET CLOCK DATE ON               => McSet(MCSET_DSHOW, .T.)
#COMMAND   SET CLOCK DATE OFF              => McSet(MCSET_DSHOW, .F.)
#COMMAND   SET CLOCK DATE (<x>)            => McSet(MCSET_DSHOW, <x>)
#COMMAND   SET CLOCK DATE TO <r>, <c>      => McSet(MCSET_DROW, <r>) ; ;
                                              McSet(MCSET_DCOL, <c>)
#COMMAND   SET CLOCK DATE COLOR TO [<*c*>] => McSet(MCSET_DCOLOR, #<c>)
#COMMAND   SET CLOCK DATE COLOR TO (<c>)   => McSet(MCSET_DCOLOR,  <c>)
#COMMAND   SET CLOCK DATE FORMAT TO <c>    => McSet(MCSET_DFORM, <c>)

#COMMAND   SET CLOCK TIME ON               => McSet(MCSET_TSHOW, .T.)
#COMMAND   SET CLOCK TIME OFF              => McSet(MCSET_TSHOW, .F.)
#COMMAND   SET CLOCK TIME (<x>)            => McSet(MCSET_TSHOW, <x>)
#COMMAND   SET CLOCK TIME TO <r>, <c>      => McSet(MCSET_TROW, <r>) ; ;
                                              McSet(MCSET_TCOL, <c>)
#COMMAND   SET CLOCK TIME COLOR TO [<*c*>] => McSet(MCSET_TCOLOR, #<c>)
#COMMAND   SET CLOCK TIME COLOR TO (<c>)   => McSet(MCSET_TCOLOR,  <c>)
#COMMAND   SET CLOCK TIME FORMAT TO <c>    => McSet(MCSET_TFORM, <c>)

#COMMAND   SET MOUSE ON                    => McSet(MCSET_MACTIVE, .T.) ; ;
                                              McSet(MCSET_MCURSOR, .T.)
#COMMAND   SET MOUSE OFF                   => McSet(MCSET_MACTIVE, .F.) ; ;
                                              McSet(MCSET_MCURSOR, .F.)
#COMMAND   SET MOUSE (<x>)                 => McSet(MCSET_MACTIVE, <x>) ; ;
                                              McSet(MCSET_MCURSOR, <x>)

#COMMAND   SET MOUSE ACTIVE ON             => McSet(MCSET_MACTIVE, .T.)
#COMMAND   SET MOUSE ACTIVE OFF            => McSet(MCSET_MACTIVE, .F.)
#COMMAND   SET MOUSE ACTIVE (<x>)          => McSet(MCSET_MACTIVE, <x>)

#COMMAND   SET MOUSE CURSOR ON             => McSet(MCSET_MCURSOR, .T.)
#COMMAND   SET MOUSE CURSOR OFF            => McSet(MCSET_MCURSOR, .F.)
#COMMAND   SET MOUSE CURSOR (<x>)          => McSet(MCSET_MCURSOR, <x>)

#COMMAND   SET MOUSE SPEED TO <x>          => McSet(MCSET_MSPEED, <x>)

#COMMAND   SET EVERCHECK TO                => McSet(MCSET_EVERCHECK, NIL)
#COMMAND   SET EVERCHECK TO <pSet>         => ;
  McSet(MCSET_EVERCHECK, {|nMode, oGet| <pSet>(nMode, oGet)})
#COMMAND   SET EVERCHECK TO <pSet:&>       => ;
  IF EMPTY(<(pSet)>) ; ;
    McSet(MCSET_EVERCHECK, NIL) ; ;
  ELSE ; ;
    McSet(MCSET_EVERCHECK, {|nMode, oGet| <pSet>(nMode, oGet)}) ; ;
  END

#COMMAND   SET READ CURSOR TO              => McSet(MCSET_RCURSOR, NIL)
#COMMAND   SET READ CURSOR TO <pSet>       => ;
  McSet(MCSET_RCURSOR, {|nMode, oGet| <pSet>(nMode, oGet)})
#COMMAND   SET READ CURSOR TO <pSet:&>     => ;
  IF EMPTY(<(pSet)>) ; ;
    McSet(MCSET_RCURSOR, NIL) ; ;
  ELSE ; ;
    McSet(MCSET_RCURSOR, {|nMode, oGet| <pSet>(nMode, oGet)}) ; ;
  END

#COMMAND   SET MEMOEDIT CURSOR TO          => McSet(MCSET_MECURSOR, NIL)
#COMMAND   SET MEMOEDIT CURSOR TO <pSet>   => McSet(MCSET_MECURSOR, ;
    {|nMode, nKey, oBrowse, oGet, aLine, nLine| ;
    <pSet>(nMode, nKey, oBrowse, oGet, aLine, nLine)})
#COMMAND   SET MEMOEDIT CURSOR TO <pSet:&> => ;
  IF EMPTY(<(pSet)>) ; ;
    McSet(MCSET_MECURSOR, NIL) ; ;
  ELSE ; ;
    McSet(MCSET_MECURSOR, {|nMode, nKey, oBrowse, oGet, aLine, nLine| ;
      <pSet>(nMode, nKey, oBrowse, oGet, aLine, nLine)}) ; ;
  END

#COMMAND   SET MEMOREAD CURSOR TO          => McSet(MCSET_MEREAD, NIL)
#COMMAND   SET MEMOREAD CURSOR TO <pSet>   => ;
  McSet(MCSET_MEREAD, {|nLine, nLines, nMode| <pSet>(nLine, nLines, nMode)})
#COMMAND   SET MEMOREAD CURSOR TO <pSet:&> => ;
  IF EMPTY(<(pSet)>) ; ;
    McSet(MCSET_MEREAD, NIL) ; ;
  ELSE ; ;
    McSet(MCSET_MEREAD, {|nLine, nLines, nMode| ; ;
      <pSet>(nLine, nLines, nMode)}) ; ;
  END

#COMMAND   SET SAVER TO           => McSet(MCSET_SAVER, NIL)
#COMMAND   SET SAVER TO <pSet>    => McSet(MCSET_SAVER, {|| <pSet>()})
#COMMAND   SET SAVER TO <pSet:&>  => ;
  IF EMPTY(<(pSet)>) ; ;
    McSet(MCSET_SAVER, NIL) ; ;
  ELSE ; ;
    McSet(MCSET_SAVER, {|| <pSet>()}) ; ;
  END

#COMMAND   SET SAVE DELAY TO <x>  => McSet(MCSET_SAVEDELAY, <x>)

#COMMAND   SET KEY RECORD ON      => McSet(MCSET_KEYRECORD, KR_RECORD)
#COMMAND   SET KEY RECORD OFF     => McSet(MCSET_KEYRECORD, KR_OFF)
#COMMAND   SET KEY RECORD (<x>)   => ;
  McSet(MCSET_KEYRECORD, IF(<x>, KR_RECORD, KR_OFF))
#COMMAND   PLAY KEY RECORD (<x>)  => ;
  McSet(MCSET_KEYRECORD, KR_PLAY) ; McKeyRecord(<x>)

#COMMAND   SET AREA <nTop>, <nLeft>, <nBottom>, <nRight> [TO] => ;
  McSetArea(<nTop>, <nLeft>, <nBottom>, <nRight>, NIL)
#COMMAND   SET AREA <nTop>, <nLeft>, <nBottom>, <nRight> TO <pSet> => ;
  McSetArea(<nTop>, <nLeft>, <nBottom>, <nRight>, ;
  {|cProc, nLine, cVar| <pSet>(cProc, nLine, cVar)})
#COMMAND   SET AREA <nTop>, <nLeft>, <nBottom>, <nRight> TO <pSet:&> => ;
  IF EMPTY(<(pSet)>) ; ;
    McSetArea(<nTop>, <nLeft>, <nBottom>, <nRight>, NIL) ; ;
  ELSE ; ;
    McSetArea(<nTop>, <nLeft>, <nBottom>, <nRight>, ;
    {|cProc, nLine, cVar| <pSet>(cProc, nLine, cVar)}) ; ;
  END

// End of MOUSCLOC.CH