/*

  DBEUTIL.PRG

  Utilities for DBE.

  This file is part of the source code for DBE, a general purpose database
  utility.

  Copyright (C) 1998 Kevin Carmody
  kcarmody@compuserve.com

  This program is free software.  You can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for more details.

  You should have received a copy of the GNU General Public License along
  with this program, in a file called COPYING.TXT.  If not, write to:

  Free Software Foundation, Inc.
  59 Temple Place, Suite 330,
  Boston, MA 02111-1307
  USA
  http://www.gnu.org

*/

#INCLUDE 'DBE.CH'
#INCLUDE 'KEYS.CH'
#INCLUDE 'CHARS.CH'
#INCLUDE 'ERROR.CH'
#INCLUDE 'MOUSCLOC.CH'

//***************************************************************************

PROCEDURE FileManager(lModify, lGlobal)

STATIC cFile      := '                                                            '
STATIC cFile2     := '                                                            '
STATIC cDrive     := 'C:                            '
STATIC cDir       := '\                                                           '
STATIC cFiles     := '*.*         '
STATIC cPrinter   := 'PRN '
STATIC lDirInc    := .Y.
STATIC lFilInc    := .Y.
STATIC lHidInc    := .N.
STATIC lAdditive  := .N.
STATIC lCodes     := .N.
STATIC aDirRow    := {1, 0}

LOCAL cSavColor    := SETCOLOR()
LOCAL cSavScreen   := SAVESCREEN()
LOCAL nContext     := Sys()[SYS_CONTEXT]
LOCAL nTop         := 3
LOCAL nBottom      := MAXROW() - IF(!lModify, 4, 6)
LOCAL nKeyLine1    := nBottom + 2
LOCAL nKeyLine2    := nBottom + 3
LOCAL nKeyLine3    := nBottom + 4
LOCAL nKeyLine4    := nBottom + 5
LOCAL oMedium      := TBROWSENEW(nTop, 13, nBottom, 68)
LOCAL oCol         := TBCOLUMNNEW('', {|| NIL})
LOCAL cBrowseColor := Sys()[SYS_COLOR][DC_TABLE]
LOCAL lBrowse      := .Y.
LOCAL nKey         := 0
LOCAL nApply       := 0
LOCAL nLine        := 1
LOCAL cDriveTrim   := ''
LOCAL cDirTrim     := ''
LOCAL cDirTrunc    := ''
LOCAL cDirCur      := ''
LOCAL cDirRoot     := ''
LOCAL cFilesTrim   := ''
LOCAL cParent      := ''
LOCAL cPath        := ''
LOCAL cName        := ''
LOCAL cRoot        := ''
LOCAL cExt         := DefaultExt()
LOCAL cSearch      := ''
LOCAL cAttr        := 'D'
LOCAL aFiles       := {}
LOCAL aDirs        := {}
LOCAL aBox         := {}
LOCAL nDir         := 1
LOCAL nPlace       := 0
LOCAL nDirs        := 0
LOCAL nFiles       := 0
LOCAL nBytes       := 0
LOCAL nRetry       := 0
LOCAL nRoot        := 0
LOCAL nSpace       := 0
LOCAL lDir         := .Y.
LOCAL lNet         := .N.
LOCAL lRefresh     := .Y.
LOCAL lMoved       := .Y.
LOCAL lLong        := LFNSupport()
LOCAL nNameCol     := IF(!lLong, 1, 6)
LOCAL bYesNo       := {|lYesNo| IF(lYesNo, 'Yes', 'No')}
//         | Alt-Tree     Alt-Files      CTRL-ENTER Select directory |
//         | ENTER Select file / Expand directory         ESC Cancel |
LOCAL aViewPad := { ;
  {nKeyLine1, 14, nKeyLine1, 21, K_ALT_T     , .Y., 'Alt-T' , 'ree'   }, ;
  {nKeyLine1, 27, nKeyLine1, 35, K_ALT_F     , .Y., 'Alt-F' , 'iles'  }, ;
  {nKeyLine1, 42, nKeyLine1, 68, K_CTRL_ENTER, .Y., ;
  'CTRL-ENTER ', 'Select directory'}, ;
  {nKeyLine2, 14, nKeyLine1, 49, K_ENTER     , .Y., ;
  'ENTER ', 'Select file / Expand directory'}, ;
  {nKeyLine2, 59, nKeyLine1, 68, K_ESC       , .Y., 'ESC '  , 'Cancel'}  }
//         | Alt-Tree   Alt-Files   Alt-Xecute   Alt-View  Alt-Print |
//         | Alt-Newfile  Alt-Edit  Alt-Rename  INS Copy  DEL Delete |
//         | Alt-List     Alt-Stats      CTRL-ENTER Select directory |
//         | ENTER Select file / Expand directory         ESC Cancel |
LOCAL aModifyPad := { ;
  {nKeyLine1, 14, nKeyLine1, 21, K_ALT_T, .Y., 'Alt-T' , 'ree'   }, ;
  {nKeyLine1, 25, nKeyLine1, 33, K_ALT_F, .Y., 'Alt-F' , 'iles'  }, ;
  {nKeyLine1, 37, nKeyLine1, 46, K_ALT_X, .Y., 'Alt-X' , 'ecute' }, ;
  {nKeyLine1, 50, nKeyLine1, 57, K_ALT_V, .Y., 'Alt-V' , 'iew'   }, ;
  {nKeyLine1, 60, nKeyLine1, 68, K_ALT_P, .Y., 'Alt-P' , 'rint'  }, ;
  {nKeyLine2, 14, nKeyLine1, 24, K_ALT_N, .Y., 'Alt-N' , 'ewfile'}, ;
  {nKeyLine2, 27, nKeyLine2, 34, K_ALT_E, .Y., 'Alt-E' , 'dit'   }, ;
  {nKeyLine2, 37, nKeyLine2, 46, K_ALT_R, .Y., 'Alt-R' , 'ename' }, ;
  {nKeyLine2, 49, nKeyLine2, 56, K_INS  , .Y., 'INS '  , 'Copy'  }, ;
  {nKeyLine2, 59, nKeyLine2, 68, K_DEL  , .Y., 'DEL '  , 'Delete'}, ;
  {nKeyLine3, 14, nKeyLine3, 21, K_ALT_L, .Y., 'Alt-L' , 'ist'   }, ;
  {nKeyLine3, 27, nKeyLine3, 35, K_ALT_S, .Y., 'Alt-S' , 'tats'  }, ;
  {nKeyLine3, 42, nKeyLine3, 68, K_CTRL_ENTER, .Y., ;
  'CTRL-ENTER ', 'Select directory'}, ;
  {nKeyLine4, 14, nKeyLine4, 49, K_ENTER     , .Y., ;
  'ENTER ', 'Select file / Expand directory'}, ;
  {nKeyLine4, 59, nKeyLine4, 68, K_ESC  , .Y., 'ESC '  , 'Cancel'}  }
LOCAL aKeyPad := IF(!lModify, aViewPad, aModifyPad)

oCol := TBCOLUMNNEW(IF(!lLong, 'Name', 'Short name'), ;
  {|| PADR(aFiles[nDir][nNameCol], 12)})
oCol:WIDTH := 12
oMedium:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Size', {|| IF('D' $ aFiles[nDir][5], ;
  PADL('<DIR>',13), TRANSFORM(aFiles[nDir][2], '9,999,999,999'))})
oCol:WIDTH := 13
oMedium:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Date', {|| DTOC(aFiles[nDir][3])})
oCol:WIDTH := LEN(SET(_SET_DATEFORMAT))
oMedium:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Time', {|| aFiles[nDir][4]})
oCol:WIDTH := 8
oMedium:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Attr', {|| PADR(aFiles[nDir][5], 5)})
oCol:WIDTH := 5
oMedium:ADDCOLUMN(oCol)
IF lLong
  oCol := TBCOLUMNNEW('Long name (1)', {|| SUBSTR(aFiles[nDir][1],   1, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (2)', {|| SUBSTR(aFiles[nDir][1],  27, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (3)', {|| SUBSTR(aFiles[nDir][1],  53, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (4)', {|| SUBSTR(aFiles[nDir][1],  79, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (5)', {|| SUBSTR(aFiles[nDir][1], 105, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (6)', {|| SUBSTR(aFiles[nDir][1], 131, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (7)', {|| SUBSTR(aFiles[nDir][1], 157, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (8)', {|| SUBSTR(aFiles[nDir][1], 183, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Long name (9)', {|| SUBSTR(aFiles[nDir][1], 209, 52)})
  oCol:WIDTH := 52
  oMedium:ADDCOLUMN(oCol)
END
oMedium:GOTOPBLOCK    := {|| nDir := 1}
oMedium:GOBOTTOMBLOCK := {|| nDir := LEN(aFiles)}
oMedium:SKIPBLOCK     := {|nSkip, nDirOld| nDirOld := nDir, ;
  (nDir := MIN(MAX(nDir + nSkip, 1), LEN(aFiles))) - nDirOld}
oMedium:COLORSPEC     := cBrowseColor
oMedium:HEADSEP       := C_SS_T_TOP + C_S_HORIZ
oMedium:COLSEP        := C_S_VERT

cFiles := PADR('*' + IF(EMPTY(cExt), '.*', cExt), LEN(cFiles))

IF lGlobal
  BoxGet('PATH',, { ;
    {'Drive:', cDrive, {|cVal| cDrive := cVal}, '@F'}, ;
    {'Directory:', cDir, {|cVal| cDir := cVal}, '@F'}, ;
    {'Files:', cFiles, {|cVal| cFiles := cVal}, '@F'}, ;
    {'Include subdirectories:', ;
    lDirInc, {|lVal| lDirInc := lVal}}, ;
    {'Include files:', ;
    lFilInc, {|lVal| lFilInc := lVal}}, ;
    {'Include hidden and system files:', ;
    lHidInc, {|lVal| lHidInc := lVal}}})
  IF LASTKEY() == K_ESC
    lBrowse := .N.
  END
END

IF lBrowse
  SETCOLOR(cBrowseColor)
  aBox := McBox({nTop-1, 12, nBottom+1, 69, .Y., .N.,,,,, .Y., .N.})
  @ nKeyLine1, 12 CLEAR TO IF(!lModify, nKeyLine2, nKeyLine4), 69
  SayInitial(aKeyPad)
END

WHILE lBrowse

  BEGIN SEQUENCE

    nRetry := 0

    IF lRefresh

      IF !lGlobal

        cPath      := Sys()[SYS_LOCAL]
        IF !EMPTY(cPath)
          nPlace     := AT(':', cPath)
          cDrive     := PADR(LEFT(cPath, nPlace), LEN(cDrive))
          cDir       := PADR(SUBSTR(cPath, nPlace + 1), LEN(cDir))
          cDriveTrim := ALLTRIM(cDrive)
          cDirTrim   := ALLTRIM(cDir)
        END
        cFilesTrim := ALLTRIM(cFiles)
        cPath      := cDriveTrim + cDirTrim + cFilesTrim
        McBox({nTop-1, 12, nBottom+1, 69, .Y., .N.,,,,, .Y., .N.}, ;
          Dots(cFilesTrim, 56, .Y.),,,, .N.)
        BoxStatus('Scanning...')

        aFiles := DIRECTORY(cPath)
        IF EMPTY(aFiles)
          Sys()[SYS_CONTEXT] := H_MANRETRY
          nPlace := ALERT('No files ' + cPath + '.;' + ;
            'Try another tree or file spec?', {'Tree', 'Files', 'Cancel'})
          DO CASE
          CASE nPlace == 1
            nRetry := K_ALT_T
          CASE nPlace == 2
            nRetry := K_ALT_F
          END
          BREAK
        END
        IF lLong
          AEVAL(aFiles, {|aFile, nFile, cFile| cFile := aFile[1], ;
            cFile := IF(cFile == '.' .OR. cFile == '..', cFile, ;
            LFNShort(cDriveTrim + cDirTrim + cFile)), ;
            AADD(aFiles[nFile], SUBSTR(cFile, RAT('\', cFile) + 1))})
        END
        nPlace := ASCAN(aFiles, {|aFile| aFile[1] == '.'})
        IF !EMPTY(nPlace)
          ADEL(aFiles, nPlace)
          ASIZE(aFiles, LEN(aFiles) - 1)
        END
        nPlace := ASCAN(aFiles, {|aFile| aFile[1] == '..'})
        IF !EMPTY(nPlace)
          ADEL(aFiles, nPlace)
          ASIZE(aFiles, LEN(aFiles) - 1)
        END

      ELSE

        cAttr := IF(lDirInc, 'D', '') + IF(lFilInc .AND. lHidInc, 'HS', '')
        cDriveTrim := STRTRAN(ALLTRIM(cDrive), '/', '\')
        IF RIGHT(cDriveTrim, 1) # ':'
          cDriveTrim += ':'
        END
        lNet     := LEN(cDriveTrim) > 2
        cDrive   := PADR(cDriveTrim, LEN(cDrive))
        cDirRoot := IF(!lNet, '\', '')

        cDirTrim := STRTRAN(ALLTRIM(cDir), '/', '\')
        IF !lNet .AND. EMPTY(cDirTrim)
          cDirTrim := '.'
        END
        IF RIGHT(cDirTrim, 1) # '\'
          cDirTrim += '\'
        END
        cDirTrunc := IF(cDirTrim == cDirRoot, cDirTrim, ;
          LEFT(cDirTrim, LEN(cDirTrim) - 1))
        DO CASE
        CASE !lNet .AND. LEFT(cDirTrunc, 1) # '\'
          cDirCur   := CURDIR(cDriveTrim)
          cDirTrunc := ;
            '\' + cDirCur + IF(EMPTY(cDirCur), '', '\') + cDirTrunc
        CASE lNet .AND. LEFT(cDirTrunc, 1) == '\'
          cDirTrunc := SUBSTR(cDirTrunc, 2)
        END
        nPlace  := RAT('\', cDirTrunc)
        cDirCur := SUBSTR(cDirTrunc, nPlace + 1)
        DO CASE
        CASE cDirCur == '.'
          cDirTrunc := LEFT(cDirTrunc, nPlace - 1)
        CASE cDirCur == '..'
          cDirTrunc := LEFT(cDirTrunc, nPlace - 1)
          nPlace    := RAT('\', cDirTrunc)
          cDirTrunc := LEFT(cDirTrunc, nPlace - 1)
        END
        cDirTrim   := cDirTrunc + IF(cDirTrunc == cDirRoot, '', '\')
        cDir       := PADR(cDirTrim, LEN(cDir))

        cFilesTrim := ALLTRIM(cFiles)
        cPath      := cDriveTrim + cDirTrim + cFilesTrim
        McBox({nTop-1, 12, nBottom+1, 69, .Y., .N.,,,,, .Y., .N.}, ;
          Dots(cPath, 56, .Y.),,,, .N.)
        BoxStatus('Scanning...')

        aFiles := DIRECTORY(cPath, cAttr)
        IF !lFilInc
          FOR nPlace := 1 TO LEN(aFiles)
            IF !('D' $ aFiles[nPlace][5])
              ADEL(aFiles, nPlace)
              ASIZE(aFiles, LEN(aFiles) - 1)
              nPlace --
            END
          NEXT
        END
        IF lDirInc .AND. !(cFilesTrim == '*.*')
          aDirs := DIRECTORY(cDriveTrim + cDirTrim + '*.*', cAttr)
          FOR nPlace := 1 TO LEN(aDirs)
            IF !('D' $ aDirs[nPlace][5])
              ADEL(aDirs, nPlace)
              ASIZE(aDirs, LEN(aDirs) - 1)
              nPlace --
            END
          NEXT
          FOR nPlace := 1 TO LEN(aDirs)
            IF EMPTY(ASCAN(aFiles, {|aRow| aRow[1] == aDirs[nPlace][1]}))
              AADD(aFiles, ACLONE(aDirs[nPlace]))
            END
          NEXT
        END

        IF EMPTY(aFiles)
          DO CASE
          CASE EMPTY(DIRECTORY(cDriveTrim + '\*.*', 'DH'))
            Sys()[SYS_CONTEXT] := H_MANRETRY
            nPlace := ALERT('Drive ' + cDriveTrim + ;
              ' not found.;Try another tree spec?', {'Tree', 'Cancel'})
            IF nPlace == 1
              nRetry := K_ALT_T
            END
            BREAK
          CASE EMPTY(DIRECTORY(cDriveTrim + cDirTrunc, 'DH'))
            Sys()[SYS_CONTEXT] := H_MANRETRY
            nPlace := ALERT('Directory ' + cDriveTrim + cDirTrim + ;
              ' not found.;Try another tree spec?', {'Tree', 'Cancel'})
            IF nPlace == 1
              nRetry := K_ALT_T
            END
            BREAK
          END
        END

        IF lLong
          AEVAL(aFiles, {|aFile, nFile, cFile| cFile := aFile[1], ;
            cFile := IF(cFile == '.' .OR. cFile == '..', cFile, ;
            LFNShort(cDriveTrim + cDirTrim + cFile)), ;
            AADD(aFiles[nFile], SUBSTR(cFile, RAT('\', cFile) + 1))})
        END
        nPlace := ASCAN(aFiles, {|aFile| aFile[1] == '.'})
        DO CASE
        CASE !EMPTY(nPlace) .AND. !(cDirTrim == cDirRoot)
          ADEL(aFiles, nPlace)
          ASIZE(aFiles, LEN(aFiles) - 1)
        CASE EMPTY(nPlace) .AND. cDirTrim == cDirRoot
          AADD(aFiles, IF(!lLong, ;
            {'.', 0, CTOD(''), '', 'D'     }, ;
            {'.', 0, CTOD(''), '', 'D', '.'}  ))
        END
        nPlace := ASCAN(aFiles, {|aFile| aFile[1] == '..'})
        IF EMPTY(nPlace) .AND. !(cDirTrim == cDirRoot)
          AADD(aFiles, IF(!lLong, ;
            {'..', 0, CTOD(''), '', 'D'      }, ;
            {'..', 0, CTOD(''), '', 'D', '..'}  ))
        END

      END

      ASORT(aFiles,,, {|aFile1, aFile2| ;
        IF('D' $ aFile1[5], '0', '1') + aFile1[nNameCol] <= ;
        IF('D' $ aFile2[5], '0', '1') + aFile2[nNameCol]})
      BoxStatus()
      cSearch := ''
      IF !lMoved
        aDirRow := {oMedium:ROWPOS, LEN(aFiles)}
      ELSE
        oMedium:GOTOP()
      END
      DISPBEGIN()
        oMedium:COLPOS := MAX(oMedium:COLPOS, 5)
        oMedium:REFRESHALL()
        CenterStable(oMedium,, {|| nDir}, LEN(aFiles))
        IF !lMoved
          RowSet(oMedium, aDirRow, @nDir, LEN(aFiles))
        END
      DISPEND()
      McTBCross(oMedium, 2, 1, 1, 2)
      lRefresh := .N.
      lMoved   := .N.

    END

  RECOVER

    BoxStatus()
    lBrowse := .N.

  END SEQUENCE

  Sys()[SYS_CONTEXT] := nContext

  DO CASE
  CASE lBrowse
    lDir   := 'D' $ aFiles[nDir][5]
    nKey   := McTransPad(aKeyPad, INKEY(0))
    nApply := IncSeaApply(oMedium, 1, MAX(oMedium:COLPOS, 5), nKey, ;
      @cSearch, aFiles, nDir, {|aRow, cVal| LEFT(aRow[1], LEN(cVal))}, ;
      {|| nDir}, {|nVal| nDir := nVal}, {|aRow, cVal| LEN(cVal)}, ;
      {2, 1, 1, 2})
    IF nApply == TA_DOUBLECLICK
      lDir := 'D' $ aFiles[nDir][5]
    END
    nRoot := IF(lLong .AND. oMedium:COLPOS >= 6, 1, nNameCol)
    cRoot := aFiles[nDir][nRoot]
    cName := IF(!lGlobal, '', cDriveTrim + cDirTrim) + cRoot
    cFile := cDriveTrim + cDirTrim + cRoot
  CASE !EMPTY(nRetry)
    nKey := nRetry
  END

  BEGIN SEQUENCE

    DO CASE
    CASE nKey == K_ALT_T

      Sys()[SYS_CONTEXT] := H_MANTREE
      BoxGet('TREE SPEC',, { ;
        {'Drive:', cDrive, {|cVal| cDrive := cVal}, '@F'}, ;
        {'Directory:', cDir, {|cVal| cDir := cVal}, '@F'}, ;
        {'Files:', cFiles, {|cVal| cFiles := cVal}, '@F'}, ;
        {'Include subdirectories:', ;
        lDirInc, {|lVal| lDirInc := lVal}}, ;
        {'Include files:', ;
        lFilInc, {|lVal| lFilInc := lVal}}, ;
        {'Include hidden and system files:', ;
        lHidInc, {|lVal| lHidInc := lVal}}})
      IF LASTKEY() == K_ESC
        BREAK
      END
      lGlobal  := .Y.
      lRefresh := .Y.
      lMoved   := .Y.
      lBrowse  := .Y.

    CASE nKey == K_ALT_F

      Sys()[SYS_CONTEXT] := H_MANFILE
      BoxGet('FILES SPEC',, { ;
        {'Files:', cFiles, {|cVal| cFiles := cVal}, '@F'}, ;
        {'Include hidden and system files:', ;
        lHidInc, {|lVal| lHidInc := lVal}}})
      IF LASTKEY() == K_ESC
        BREAK
      END
      lRefresh := .Y.
      lMoved   := .Y.
      lBrowse  := .Y.

    CASE lModify .AND. !lDir .AND. nKey == K_ALT_X

      Command(cName)

    CASE lModify .AND. !lDir .AND. nKey == K_ALT_V

      ViewFile(cName)

    CASE lModify .AND. !lDir .AND. nKey == K_ALT_P

      Sys()[SYS_CONTEXT] := H_MANPRINT
      BoxGet('PRINT FILE',, { ;
        {cName + ' to:', cPrinter, {|cVal| cPrinter := cVal}, ;
        {'PRN', 'LPT1', 'LPT2', 'LPT3'}}, ;
        {'Printer codes:', lCodes, {|lVal| lCodes := lVal}}})
      IF LASTKEY() == K_ESC
        BREAK
      END
      PrintInit(lCodes)
      BoxStatus('Printing...', .Y.)
      PrintSet(.Y., cPrinter, .N.)
      BEGIN SEQUENCE
        QQOUT(PrintCodes(lCodes, .Y.))
        COPY FILE (cFile) TO (cPrinter)
        QQOUT(PrintCodes(lCodes, .N.))
      END SEQUENCE
      PrintSet(.N.)
      BoxStatus()

    CASE lModify .AND. nKey == K_ALT_N

      Sys()[SYS_CONTEXT] := H_MANNEW
      BoxGet('NEW FILE',, { ;
        {'Name:', cFile2, {|cVal| cFile2 := cVal}, '@F'}})
      IF EMPTY(cFile2) .OR. LASTKEY() == K_ESC
        BREAK
      END
      EditFile(cFile2)
      lRefresh := .Y.

    CASE lModify .AND. !lDir .AND. nKey == K_ALT_E

      EditFile(cFile)
      lRefresh := .Y.

    CASE lModify .AND. !lDir .AND. nKey == K_ALT_R

      Sys()[SYS_CONTEXT] := H_MANRENAME
      BoxGet('RENAME FILE',, { ;
        {cName + ' to:', cFile2, {|cVal| cFile2 := cVal}, '@F'}})
      IF EMPTY(cFile2) .OR. LASTKEY() == K_ESC
        BREAK
      END
      RENAME (cFile) TO (cFile2)
      CheckError(EG_WRITE, 'Rename', ALLTRIM(cFile), .N.)
      lRefresh := .Y.

    CASE lModify .AND. !lDir .AND. nKey == K_INS

      Sys()[SYS_CONTEXT] := H_MANCOPY
      BoxGet('COPY FILE',, { ;
        {cName + ' to:', cFile2, {|cVal| cFile2 := cVal}, '@F'}})
      IF EMPTY(cFile2) .OR. LASTKEY() == K_ESC
        BREAK
      END
      COPY FILE (cFile) TO (PathAdj(cFile2, .Y.))
      CheckError(EG_WRITE, 'Copy', ALLTRIM(cFile2), .N.)
      lRefresh := .Y.

    CASE lModify .AND. !lDir .AND. nKey == K_DEL

      IF !YesNo('Delete file ' + cName + '?', .N.)
        BREAK
      END
      ERASE (cFile)
      CheckError(EG_WRITE, 'Delete', ALLTRIM(cFile), .N.)
      lRefresh := .Y.

    CASE lModify .AND. nKey == K_ALT_L

      Sys()[SYS_CONTEXT] := H_MANLIST
      BoxGet('LIST FILES',, { ;
        {'To:', cFile2, {|cVal| cFile2 := cVal}, '@F', '.TXT'}, ;
        {'Additive:', lAdditive, {|lVal| lAdditive := lVal}}, ;
        {'Printer codes:', lCodes, {|lVal| lCodes := lVal}}})
      IF EMPTY(cFile2) .OR. LASTKEY() == K_ESC
        BREAK
      END
      PrintInit(lCodes)
      BoxStatus('Listing...')
      PrintSet(.Y., cFile2, lAdditive)
      BEGIN SEQUENCE
        QQOUT(PrintCodes(lCodes, .Y.))
        IF !lGlobal
          QQOUT('FILES', cFiles)
          QOUT ()
          QOUT ('Includes hidden and system files: ', bYesNo:EVAL(lHidInc))
          QOUT ()
        ELSE
          QQOUT('    DRIVE', ALLTRIM(cDrive))
          QOUT ('DIRECTORY', ALLTRIM(cDir))
          QOUT ('    FILES', ALLTRIM(cFiles))
          QOUT ()
          QOUT ('        Includes subdirectories: ', bYesNo:EVAL(lDirInc))
          QOUT ('                  Include files: ', bYesNo:EVAL(lFilInc))
          QOUT ('Include hidden and system files: ', bYesNo:EVAL(lHidInc))
          QOUT ()
        END
        QOUT(ListBrowse(oMedium, nDir, {|nVal| nDir := nVal}, ;
          1, LEN(aFiles)))
        QOUT()
        QOUT()
        QQOUT(PrintCodes(lCodes, .N.))
      END SEQUENCE
      PrintSet(.N.)
      BoxStatus()
      lRefresh := .Y.

    CASE lModify .AND. nKey == K_ALT_S

      BoxStatus('Calculating...')
      nDirs  := 0
      AEVAL(aFiles, {|aFile| IF('D' $ aFile[5], nDirs := nDirs + 1, NIL)})
      nFiles := LEN(aFiles) - nDirs
      nBytes := 0
      AEVAL(aFiles, {|aFile| nBytes := nBytes + aFile[2]})
      nSpace := FreeSpace(cDirTrim)
      BoxStatus()
      ALERT('FILE STATISTICS:;' + ;
        'Number of subdirectories:  ' + Commas(nDirs ) + ';' +  ;
        'Number of files:  '          + Commas(nFiles) + ';' +  ;
        'Number of bytes:  '          + Commas(nBytes) + ';' +  ;
        'Number of free bytes:  '     + Commas(nSpace)       ,, ;
        Sys()[SYS_COLOR][DC_STATUS])

    CASE !lDir .AND. (nKey == K_ENTER .OR. nKey == K_CTRL_ENTER .OR. ;
      nApply == TA_DOUBLECLICK .OR. nApply == TA_OUTBOX)

      IF !EMPTY(cExt)
        cName := PathAdj(cName,, cExt, .N.)
      END
      Transfer(cName, cName)
      lBrowse := .N.

    CASE lDir .AND. (nKey == K_ENTER .OR. nApply == TA_DOUBLECLICK)

      cDir     := PADR(cDirTrim + aFiles[nDir][nRoot], LEN(cDir))
      lRefresh := .Y.
      lMoved   := .Y.

    CASE lDir .AND. (nKey == K_CTRL_ENTER .OR. nApply == TA_OUTBOX)

      cRoot := IF(cRoot == '.' .OR. cRoot == '..', '', cRoot + '\')
      cName := IF(!lGlobal, '', cDriveTrim + cDirTrim) + cRoot
      Transfer(cName, cName)
      lBrowse := .N.

    CASE nKey == K_ESC .OR. nApply == TA_CLOSE

      lBrowse := .N.

    END

  END SEQUENCE

  Sys()[SYS_CONTEXT] := nContext

END

IF !EMPTY(aBox)
  McRestBox(aBox)
  SETCOLOR(cSavColor)
  RESTSCREEN(,,,, KRS(cSavScreen))
END

RETURN  //  FileManager

//***************************************************************************

PROCEDURE ViewStru(lAll)

STATIC nStru    := 1
STATIC aStruRow := {1, 0}

LOCAL cSavColor    := SETCOLOR()
LOCAL cSavScreen   := SAVESCREEN()
LOCAL nTop         := 3
LOCAL nBottom      := MAXROW() - 3
LOCAL nKeyLine     := nBottom + 2
LOCAL nLeft        := IF(!lAll, 12,  8)
LOCAL nRight       := IF(!lAll, 67, 71)
LOCAL oStru        := TBROWSENEW(nTop, nLeft, nBottom, nRight)
LOCAL oCol         := TBCOLUMNNEW('', {|| NIL})
LOCAL cBrowseColor := Sys()[SYS_COLOR][DC_TABLE]
LOCAL nStruLen     := IF(EMPTY(Current()), 0, DATA_STOTAL)
LOCAL nAliasCol    := nStruLen + 1
LOCAL nAreaCol     := nStruLen + 2
LOCAL nSeaBroCol   := 1
LOCAL nSeaStruCol  := 1
LOCAL aStru        := {}
LOCAL lFSort       := .Y.
LOCAL cAlias       := ''
LOCAL cField       := ''
LOCAL cSearch      := ''
LOCAL nArea        := 0
LOCAL lBrowse      := .Y.
LOCAL nKey         := 0
LOCAL nApply       := 0
LOCAL nData        := 1
LOCAL aData        := {}
LOCAL aBox         := {}
//     |     ENTER Select     Alt-Field order      Alt-Name order     |
//         | ENTER Select     Alt-Field order      Alt-Name order |
LOCAL aStrucPad := { ;
  {nKeyLine, 14, nKeyLine, 25, K_ENTER, .Y., 'ENTER', ' Select'     }, ;
  {nKeyLine, 31, nKeyLine, 45, K_ALT_F, .Y., 'Alt-F', ' Field order'}, ;
  {nKeyLine, 52, nKeyLine, 65, K_ALT_N, .Y., 'Alt-N', ' Name order' }  }

BEGIN SEQUENCE

  IF EMPTY(Current())
    ALERT('No databases open.')
    BREAK
  END

  IF !lAll
    aData  := ACLONE(Current())
    cAlias := aData[DATA_ALIAS]
    nArea  := aData[DATA_AREA]
    lFSort := aData[DATA_FSORT]
    AEVAL(aData[DATA_STRUC], {|aRow, nRow| ;
      AADD(aRow, cAlias), AADD(aRow, nArea), AADD(aStru, ACLONE(aRow))})
    nSeaBroCol  := 1
    nSeaStruCol := DATA_SNAME
  ELSE
    FOR nData := 1 TO LEN(Data())
      aData  := ACLONE(Data()[nData])
      cAlias := aData[DATA_ALIAS]
      nArea  := aData[DATA_AREA]
      AEVAL(aData[DATA_STRUC], {|aRow, nRow| ;
        AADD(aRow, cAlias), AADD(aRow, nArea), AADD(aStru, ACLONE(aRow))})
    NEXT
    lFSort := .Y.
    ASORT(aStru,,, {|aLine1, aLine2| ;
      STR(aLine1[nAreaCol], 2) + STR(aLine1[DATA_SNUM], 6) <= ;
      STR(aLine2[nAreaCol], 2) + STR(aLine2[DATA_SNUM], 6) })
    nSeaBroCol  := IF(lFSort, 1, 2)
    nSeaStruCol := IF(lFSort, nAliasCol, DATA_SNAME)
  END

  IF lAll
    oCol := TBCOLUMNNEW('Alias',      {|| PADR(aStru[nStru][nAliasCol], 8)})
    oCol:WIDTH := 8
    oStru:ADDCOLUMN(oCol)
  END
  oCol := TBCOLUMNNEW('Field;Name', {|| PADR(aStru[nStru][DATA_SNAME], 10)})
  oCol:WIDTH := 10
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Type',       {|| PADC(aStru[nStru][DATA_STYPE],  4)})
  oCol:WIDTH := 4
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Length',        {|| STR(aStru[nStru][DATA_SLEN], 6)})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Dec',           {|| STR(aStru[nStru][DATA_SDEC], 3)})
  oCol:WIDTH := 3
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW(' Field;Number', {|| STR(aStru[nStru][DATA_SNUM], 6)})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('   Start;    Byte', ;
    {|| STR(aStru[nStru][DATA_SPOS], 8)})
  oCol:WIDTH := 8
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('     End;    Byte', ;
    {|| STR(aStru[nStru][DATA_SPOS] + aStru[nStru][DATA_SLEN] - 1, 8)})
  oCol:WIDTH := 8
  oStru:ADDCOLUMN(oCol)
  oStru:GOTOPBLOCK    := {|| nStru := 1}
  oStru:GOBOTTOMBLOCK := {|| nStru := LEN(aStru)}
  oStru:SKIPBLOCK     := {|nSkip, nStruOld| nStruOld := nStru, ;
    (nStru := MIN(MAX(nStru + nSkip, 1), LEN(aStru))) - nStruOld}
  oStru:COLORSPEC     := cBrowseColor
  oStru:HEADSEP       := C_SS_T_TOP + C_S_HORIZ
  oStru:COLSEP        := C_S_VERT

  SETCOLOR(cBrowseColor)
  aBox := ;
    McBox({nTop-1, nLeft-1, nBottom+1, nRight+1, .Y., .N.,,,,, .Y., .N.}, ;
    IF(!lAll, cAlias, NIL))
  @ nKeyLine, nLeft-1 CLEAR TO nKeyLine, nRight+1
  SayInitial(aStrucPad)
  RowSet(oStru, aStruRow, @nStru, LEN(aStru))
  CenterStable(oStru, {2, 1, 1, 2}, {|| nStru}, LEN(aStru))
  WHILE lBrowse
    nKey   := McTransPad(aStrucPad, INKEY(0))
    nApply := IncSeaApply(oStru, nSeaBroCol,, nKey, @cSearch, aStru,, ;
      {|aRow, cVal| LEFT(aRow[nSeaStruCol], LEN(cVal))}, ;
      {|| nStru}, {|nVal| nStru := nVal}, {|aRow, cVal| LEN(cVal)}, ;
      {2, 1, 1, 2})
    DO CASE
    CASE nKey == K_ALT_F
      ASORT(aStru,,, {|aLine1, aLine2| ;
        STR(aLine1[nAreaCol], 2) + STR(aLine1[DATA_SNUM], 6) <= ;
        STR(aLine2[nAreaCol], 2) + STR(aLine2[DATA_SNUM], 6) })
      lFSort      := .Y.
      nSeaBroCol  := 1
      nSeaStruCol := IF(lAll, nAliasCol, DATA_SNAME)
      oStru:REFRESHALL()
      CenterStable(oStru, {2, 1, 1, 2}, {|| nStru}, LEN(aStru))
    CASE nKey == K_ALT_N
      ASORT(aStru,,, {|aLine1, aLine2| ;
        PADR(aLine1[DATA_SNAME], 10) + PADR(aLine1[nAliasCol], 8) <= ;
        PADR(aLine2[DATA_SNAME], 10) + PADR(aLine2[nAliasCol], 8) })
      lFSort      := .N.
      nSeaBroCol  := IF(lAll, 2, 1)
      nSeaStruCol := DATA_SNAME
      oStru:REFRESHALL()
      CenterStable(oStru, {2, 1, 1, 2}, {|| nStru}, LEN(aStru))
    CASE nKey == K_ESC .OR. nApply == TA_CLOSE
      lBrowse := .N.
    CASE nKey == K_ENTER .OR. nApply == TA_DOUBLECLICK .OR. ;
      nApply == TA_OUTBOX
      cField := IF(!lAll, '', aStru[nStru][nAliasCol] + '->') + ;
        aStru[nStru][DATA_SNAME]
      Transfer(cField, {|oGet| IF(oGet:TYPE # 'C', NIL, ;
        oGet:VARPUT(PADR(STUFF(oGet:BUFFER, oGet:POS, 0, cField), ;
        LEN(oGet:BUFFER))))})
      lBrowse := .N.
    END
  END
  aStruRow := {oStru:ROWPOS, LEN(aStru)}
  McRestBox(aBox)

END SEQUENCE

SETCOLOR(cSavColor)
RESTSCREEN(,,,, KRS(cSavScreen))

RETURN  //  ViewStru

//***************************************************************************

PROCEDURE FieldManager()

STATIC nStru    := 1
STATIC aStruRow := {1, 0}

LOCAL cSavColor    := SETCOLOR()
LOCAL cSavScreen   := SAVESCREEN()
LOCAL aData        := ACLONE(Current())
LOCAL cAlias       := aData[DATA_ALIAS]
LOCAL nArea        := aData[DATA_AREA]
LOCAL aField       := aData[DATA_FIELD]
LOCAL aRStru       := aData[DATA_STRUC]
LOCAL nRStru       := 1
LOCAL aRelation    := aData[DATA_RELATION]
LOCAL nRelation    := 1
LOCAL lAll         := !EMPTY(aRelation)
LOCAL nTop         := 3
LOCAL nBottom      := MAXROW() - 3
LOCAL nKeyLine     := nBottom + 2
LOCAL nLeft        := IF(!lAll,  8,  4)
LOCAL nRight       := IF(!lAll, 71, 75)
LOCAL oStru        := TBROWSENEW(nTop, nLeft, nBottom, nRight)
LOCAL oCol         := TBCOLUMNNEW('', {|| NIL})
LOCAL cBrowseColor := Sys()[SYS_COLOR][DC_TABLE]
LOCAL nStruLen     := DATA_STOTAL
LOCAL nAliasCol    := nStruLen + 1
LOCAL nAreaCol     := nStruLen + 2
LOCAL nCurCol      := nStruLen + 3
LOCAL nSetCol      := nStruLen + 4
LOCAL nStruTot     := nSetCol
LOCAL nSeaBroCol   := IF(!lAll, 2, 3)
LOCAL nField       := 1
LOCAL lField       := .N.
LOCAL lCurCol      := .N.
LOCAL lSetCol      := .N.
LOCAL aFField      := {}
LOCAL aRField      := {}
LOCAL cName        := ''
LOCAL cRAlias      := ''
LOCAL cMAlias      := ''
LOCAL nRArea       := 0
LOCAL aStru        := {}
LOCAL cSearch      := ''
LOCAL lBrowse      := .Y.
LOCAL lSave        := .N.
LOCAL lChange      := .N.
LOCAL nKey         := 0
LOCAL nApply       := 0
LOCAL nData        := 1
LOCAL aBox         := {}
// |         SPACE Select/Deselect       END Save      ESC Cancel         |
//    |      SPACE Select/Deselect       END Save      ESC Cancel      |
LOCAL aStrucPad := { ;
  {nKeyLine, 14, nKeyLine, 34, K_SPACE, .Y., 'SPACE', ' Select/Deselect'}, ;
  {nKeyLine, 42, nKeyLine, 49, K_END  , .Y., 'END'  , ' Save'           }, ;
  {nKeyLine, 56, nKeyLine, 65, K_ESC  , .Y., 'ESC'  , ' Cancel'         }  }

BEGIN SEQUENCE

  FOR nRStru := 1 TO LEN(aRStru)
    aRField := ACLONE(aRStru[nRStru])
    nField  := ASCAN(aField, {|aRow| ;
      EMPTY(aRow[DATA_FEXP]) .AND. ;
      EMPTY(aRow[DATA_FALIAS]) .AND. ;
      aRow[DATA_FNAME] == aRField[DATA_SNAME]})
    lField  := !EMPTY(nField)
    ASIZE(aRField, nStruTot)
    aRField[nAliasCol] := cAlias
    aRField[nAreaCol]  := nArea
    aRField[nCurCol]   := lField
    aRField[nSetCol]   := lField
    AADD(aStru, ACLONE(aRField))
  NEXT

  FOR nRelation := 1 TO LEN(aRelation)
    cRAlias := aRelation[nRelation][DATA_RALIAS]
    nData   := ASCAN(Data(), {|aRow| aRow[DATA_ALIAS] == cRAlias})
    aData   := ACLONE(Data()[nData])
    aRStru  := aData[DATA_STRUC]
    nRArea  := aData[DATA_AREA]
    FOR nRStru := 1 TO LEN(aRStru)
      aRField := ACLONE(aRStru[nRStru])
      nField  := ASCAN(aField, {|aRow| ;
        EMPTY(aRow[DATA_FEXP]) .AND. ;
        aRow[DATA_FALIAS] == cRAlias .AND. ;
        aRow[DATA_FNAME] == aRField[DATA_SNAME]})
      lField  := !EMPTY(nField)
      ASIZE(aRField, nStruTot)
      aRField[nAliasCol] := cRAlias
      aRField[nAreaCol]  := nRArea
      aRField[nCurCol]   := lField
      aRField[nSetCol]   := lField
      AADD(aStru, ACLONE(aRField))
    NEXT
  NEXT

  oCol := TBCOLUMNNEW('Select', ;
    {|| PADC(IF(aStru[nStru][nSetCol], ;
     C_DIAMOND + IF(aStru[nStru][nCurCol], ' ', '+'), ;
     ' ' + IF(aStru[nStru][nCurCol], '-', ' ')), 6)})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  IF lAll
    oCol := TBCOLUMNNEW('Alias',      {|| PADR(aStru[nStru][nAliasCol], 8)})
    oCol:WIDTH := 8
    oStru:ADDCOLUMN(oCol)
  END
  oCol := TBCOLUMNNEW('Field;Name', {|| PADR(aStru[nStru][DATA_SNAME], 10)})
  oCol:WIDTH := 10
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Type',       {|| PADC(aStru[nStru][DATA_STYPE],  4)})
  oCol:WIDTH := 4
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Length',        {|| STR(aStru[nStru][DATA_SLEN], 6)})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Dec',           {|| STR(aStru[nStru][DATA_SDEC], 3)})
  oCol:WIDTH := 3
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW(' Field;Number', {|| STR(aStru[nStru][DATA_SNUM], 6)})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('   Start;    Byte', ;
    {|| STR(aStru[nStru][DATA_SPOS], 8)})
  oCol:WIDTH := 8
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('     End;    Byte', ;
    {|| STR(aStru[nStru][DATA_SPOS] + aStru[nStru][DATA_SLEN] - 1, 8)})
  oCol:WIDTH := 8
  oStru:ADDCOLUMN(oCol)
  oStru:GOTOPBLOCK    := {|| nStru := 1}
  oStru:GOBOTTOMBLOCK := {|| nStru := LEN(aStru)}
  oStru:SKIPBLOCK     := {|nSkip, nStruOld| nStruOld := nStru, ;
    (nStru := MIN(MAX(nStru + nSkip, 1), LEN(aStru))) - nStruOld}
  oStru:COLORSPEC     := cBrowseColor
  oStru:HEADSEP       := C_SS_T_TOP + C_S_HORIZ
  oStru:COLSEP        := C_S_VERT

  SETCOLOR(cBrowseColor)
  aBox := ;
    McBox({nTop-1, nLeft-1, nBottom+1, nRight+1, .Y., .N.,,,,, .Y., .N.}, ;
    IF(!lAll, cAlias, NIL))
  @ nKeyLine, nLeft-1 CLEAR TO nKeyLine, nRight+1
  SayInitial(aStrucPad)
  RowSet(oStru, aStruRow, @nStru, LEN(aStru))
  WHILE lBrowse
    CenterStable(oStru, {2, 1, 1, 2}, {|| nStru}, LEN(aStru))
    nKey := McTransPad(aStrucPad, INKEY(0))
    IF nKey == K_SPACE
      nApply := McTBApplyKey(oStru, nKey)
      McScrollBox(nStru, LEN(aStru))
    ELSE
      nApply := IncSeaApply(oStru, nSeaBroCol,, nKey, @cSearch, aStru,, ;
        {|aRow, cVal| LEFT(aRow[1], LEN(cVal))}, ;
        {|| nStru}, {|nVal| nStru := nVal}, {|aRow, cVal| LEN(cVal)}, ;
        {2, 1, 1, 2})
    END
    DO CASE
    CASE nKey == K_SPACE .OR. nApply == TA_DOUBLECLICK
      aStru[nStru][nSetCol] := !aStru[nStru][nSetCol]
      oStru:REFRESHCURRENT()
      IF nKey == K_SPACE
        oStru:DOWN()
      END
    CASE (nKey == K_ESC .OR. nApply == TA_CLOSE) .AND. ;
      YesNo('Discard changes and exit?', .Y.)
      lBrowse := .N.
    CASE (nKey == K_END .OR. nKey == K_CTRL_END .OR. ;
      nApply == TA_OUTBOX) .AND. YesNo('Save changes and exit?', .Y.)
      lSave   := .Y.
      lBrowse := .N.
    END
  END
  aStruRow := {oStru:ROWPOS, LEN(aStru)}
  McRestBox(aBox)

  IF lSave

    FOR nRStru := 1 TO LEN(aStru)

      aRField := aStru[nRStru]
      lCurCol := aRField[nCurCol]
      lSetCol := aRField[nSetCol]

      DO CASE
      CASE lCurCol .AND. !lSetCol
        cRAlias := aRField[nAliasCol]
        cMAlias := IF(cAlias == cRAlias, '', cRAlias)
        nField  := ASCAN(Current()[DATA_FIELD], {|aRow| ;
          EMPTY(aRow[DATA_FEXP]) .AND. ;
          aRow[DATA_FALIAS] == cMAlias .AND. ;
          aRow[DATA_FNAME] == aRField[DATA_SNAME]})
        ADEL(Current()[DATA_FIELD], nField)
        ASIZE(Current()[DATA_FIELD], LEN(Current()[DATA_FIELD]) - 1)
        lChange := .Y.
      CASE !lCurCol .AND. lSetCol
        cRAlias := aRField[nAliasCol]
        nRArea  := aRField[nAreaCol]
        cName   := aRField[DATA_SNAME]
        nField  := Current()[DATA_FMAX] + 1
        aFField   := ARRAY(DATA_FTOTAL)
        aFField[DATA_FNAME]  := cName
        aFField[DATA_FNUM]   := nField
        aFField[DATA_FALIAS] := IF(cAlias == cRAlias, '', cRAlias)
        aFField[DATA_FEXP]   := ''
        aFField[DATA_FBLOCK] := IF(cAlias == cRAlias, ;
          FIELDBLOCK(cName), FIELDWBLOCK(cName, nRArea))
        aFField[DATA_FEDIT]  := .Y.
        aFField[DATA_FTYPE]  := aRField[DATA_STYPE]
        aFField[DATA_FLEN]   := aRField[DATA_SLEN]
        aFField[DATA_FDEC]   := aRField[DATA_SDEC]
        AADD(Current()[DATA_FIELD], ACLONE(aFField))
        lChange := .Y.
      END

    NEXT

  END

END SEQUENCE

SETCOLOR(cSavColor)
RESTSCREEN(,,,, KRS(cSavScreen))

IF lChange
  RefreshSetup()
  IF LEN(Current()[DATA_FIELD]) == 1
    Current()[DATA_NFIELD] := 1
  END
  Current()[DATA_FMAX]  := nField
  Current()[DATA_FINIT] := .N.
  EditInit(.N.)
END

RETURN  //  FieldManager

//***************************************************************************

FUNCTION EditStru(aCurStru, cTitle)

STATIC nStru    := 1
STATIC aStruRow := {1, 0}

LOCAL cSavColor    := SETCOLOR()
LOCAL cSavScreen   := SAVESCREEN()
LOCAL nContext     := Sys()[SYS_CONTEXT]
LOCAL nTop         := 3
LOCAL nBottom      := MAXROW() - 2
LOCAL oStru        := TBROWSENEW(nTop, 12, nBottom-3, 67)
LOCAL oCol         := TBCOLUMNNEW('', {|| NIL})
LOCAL cBrowseColor := Sys()[SYS_COLOR][DC_TABLE]
LOCAL aStru        := ACLONE(aCurStru)
LOCAL cSearch      := ''
LOCAL lBrowse      := .Y.
LOCAL lCalc        := .N.
LOCAL nKey         := 0
LOCAL cKey         := ''
LOCAL nApply       := 0
LOCAL aField       := {}
LOCAL aField1      := {}
LOCAL aField2      := {}
LOCAL nPos         := 1
LOCAL aBox         := {}
LOCAL GetList      := {}
LOCAL bType        := {|cType, lValid| ;
  lValid := !EMPTY(ASCAN({'C', 'N', 'D', 'L', 'M'}, cType)), ;
  IF(lValid, NIL, ALERT('Enter C, N, D, L, or M.')), lValid}
//        |INS Add  DEL Delete  ENTER Edit  Ctrl-^ Move Ctrl-V Move|
//        |                END Save      ESC Cancel                |
LOCAL aStrucPad := { ;
  {nBottom-1, 12, nBottom-1, 18, K_INS      , .Y., 'INS '  , 'Add'   }, ;
  {nBottom-1, 21, nBottom-1, 30, K_DEL      , .Y., 'DEL '  , 'Delete'}, ;
  {nBottom-1, 33, nBottom-1, 42, K_ENTER    , .Y., 'ENTER ', 'Edit'  }, ;
  {nBottom-1, 45, nBottom-1, 55, K_CTRL_UP  , .Y., 'Ctrl-' + C_UP_ARROW  , ;
  ' Move'}, ;
  {nBottom-1, 57, nBottom-1, 67, K_CTRL_DOWN, .Y., 'Ctrl-' + C_DOWN_ARROW, ;
  ' Move'}, ;
  {nBottom  , 28, nBottom  , 35, K_END      , .Y., 'END '  , 'Save'  }, ;
  {nBottom  , 42, nBottom  , 51, K_ESC      , .Y., 'ESC '  , 'Cancel'}  }

Sys()[SYS_CONTEXT] := H_STRUEDIT

BEGIN SEQUENCE

  ASORT(aStru,,, {|aLine1, aLine2| aLine1[DATA_SNUM] <= aLine2[DATA_SNUM]})
  AEVAL(aStru, {|aLine, nLine| ;
    aStru[nLine][DATA_SNAME] := PADR(aStru[nLine][DATA_SNAME], 10)})

  oCol := TBCOLUMNNEW('Field;Name', ;
    {|| IF(EMPTY(aStru), '', PADR(aStru[nStru][DATA_SNAME], 10))})
  oCol:WIDTH := 10
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Type', ;
    {|| IF(EMPTY(aStru), '', PADC(aStru[nStru][DATA_STYPE],  4))})
  oCol:WIDTH := 4
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Length', ;
    {|| IF(EMPTY(aStru), '', STR(aStru[nStru][DATA_SLEN], 6))})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('Dec', ;
    {|| IF(EMPTY(aStru), '', STR(aStru[nStru][DATA_SDEC], 3))})
  oCol:WIDTH := 3
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW(' Field;Number', ;
    {|| IF(EMPTY(aStru), '', STR(aStru[nStru][DATA_SNUM], 6))})
  oCol:WIDTH := 6
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('   Start;    Byte', ;
    {|| IF(EMPTY(aStru), '', STR(aStru[nStru][DATA_SPOS], 8))})
  oCol:WIDTH := 8
  oStru:ADDCOLUMN(oCol)
  oCol := TBCOLUMNNEW('     End;    Byte', {|| IF(EMPTY(aStru), '', ;
    STR(aStru[nStru][DATA_SPOS] + aStru[nStru][DATA_SLEN] - 1, 8))})
  oCol:WIDTH := 8
  oStru:ADDCOLUMN(oCol)
  oStru:GOTOPBLOCK    := {|| nStru := 1}
  oStru:GOBOTTOMBLOCK := {|| nStru := MAX(1, LEN(aStru))}
  oStru:SKIPBLOCK     := {|nSkip, nStruOld| nStruOld := nStru, ;
    (nStru := MAX(MIN(nStru + nSkip, LEN(aStru)), 1)) - nStruOld}
  oStru:COLORSPEC     := cBrowseColor
  oStru:HEADSEP       := C_SS_T_TOP + C_S_HORIZ
  oStru:COLSEP        := C_S_VERT

  SETCOLOR(cBrowseColor)
  aBox := McBox({nTop-1, 11, nBottom-2, 68, .Y., .N.,,,,, .Y., .N.}, cTitle)
  @ nBottom-1, 11 CLEAR TO nBottom, 68
  SayInitial(aStrucPad)
  RowSet(oStru, aStruRow, @nStru, LEN(aStru))
  CenterStable(oStru, {2, 1, 1, 2}, {|| nStru}, LEN(aStru))
  WHILE lBrowse
    nKey   := McTransPad(aStrucPad, INKEY(0))
    nApply := IncSeaApply(oStru, 1,, nKey, @cSearch, aStru,, ;
      {|aRow, cVal| LEFT(aRow[DATA_SNAME], LEN(cVal))}, ;
      {|| nStru}, {|nVal| nStru := nVal}, {|aRow, cVal| LEN(cVal)}, ;
      {2, 1, 1, 2})
    DO CASE
    CASE nKey == K_INS
      ASIZE(aStru, LEN(aStru) + 1)
      AINS(aStru, nStru)
      aStru[nStru] := ARRAY(DATA_STOTAL)
      aField := ACLONE(aStru[nStru])
      aField[DATA_SNAME] := ;
        PADR('FIELD' + STRZERO(nStru, LENNUM(LEN(aStru))), 10)
      aField[DATA_STYPE] := 'C'
      aField[DATA_SLEN]  := 10
      aField[DATA_SDEC]  := 0
      aField[DATA_SNUM]  := nStru
      aField[DATA_SPOS]  := 0
      aStru[nStru] := ACLONE(aField)
      lCalc := .Y.
    CASE nKey == K_DEL
      ADEL(aStru, nStru)
      ASIZE(aStru, LEN(aStru) - 1)
      lCalc := .Y.
    CASE nKey == K_ENTER .OR. nApply == TA_DOUBLECLICK
      McTBCross(oStru, 1, 1, 1, 1, .N.)
      aField := ACLONE(aStru[nStru])
      @ ROW(), 15 GET aField[DATA_SNAME] PICTURE '!!!!!!!!!!'
      @ ROW(), 27 GET aField[DATA_STYPE] PICTURE '!'          ;
        VALID bType:EVAL(aField[DATA_STYPE])
      @ ROW(), 31 GET aField[DATA_SLEN]  PICTURE '999999'     ;
        WHEN aField[DATA_STYPE] == 'C' .OR. aField[DATA_STYPE] == 'N'
      @ ROW(), 38 GET aField[DATA_SDEC]  PICTURE '999'        ;
        WHEN aField[DATA_STYPE] == 'N'
      READ
      DO CASE
      CASE aField[DATA_STYPE] == 'C'
        aField[DATA_SDEC] := 0
      CASE aField[DATA_STYPE] == 'D'
        aField[DATA_SLEN] := 8
        aField[DATA_SDEC] := 0
      CASE aField[DATA_STYPE] == 'L'
        aField[DATA_SLEN] := 1
        aField[DATA_SDEC] := 0
      CASE aField[DATA_STYPE] == 'M'
        aField[DATA_SLEN] := 10
        aField[DATA_SDEC] := 0
      END
      aStru[nStru] := ACLONE(aField)
      lCalc := .Y.
    CASE (nKey == K_CTRL_UP .OR. nKey == K_ALT_U) .AND. nStru >= 2
      aField1 := ACLONE(aStru[nStru  ])
      aField2 := ACLONE(aStru[nStru-1])
      aStru[nStru-1] := ACLONE(aField1)
      aStru[nStru  ] := ACLONE(aField2)
      oStru:UP()
      lCalc := .Y.
    CASE (nKey == K_CTRL_DOWN .OR. nKey == K_ALT_B) .AND. ;
      nStru <= LEN(aStru) - 1
      aField1 := ACLONE(aStru[nStru  ])
      aField2 := ACLONE(aStru[nStru+1])
      aStru[nStru+1] := ACLONE(aField1)
      aStru[nStru  ] := ACLONE(aField2)
      oStru:DOWN()
      lCalc := .Y.
    CASE (nKey == K_ESC .OR. nApply == TA_CLOSE) .AND. ;
      YesNo('Discard changes and exit?', .Y.)
      aStru   := {}
      lBrowse := .N.
    CASE (nKey == K_END .OR. nKey == K_CTRL_END .OR. ;
      nApply == TA_OUTBOX) .AND. YesNo('Save changes and exit?', .Y.)
      lBrowse := .N.
    END
    IF lCalc
      nPos := 1
      AEVAL(aStru, {|aField, nField| aStru[nField][DATA_SNUM] := nField, ;
        aStru[nField][DATA_SPOS] := nPos, nPos += aField[DATA_SLEN]})
      oStru:REFRESHALL()
      CenterStable(oStru, {2, 1, 1, 2}, {|| nStru}, LEN(aStru))
      lCalc := .N.
    END
  END
  aStruRow := {oStru:ROWPOS, LEN(aStru)}
  McRestBox(aBox)

END SEQUENCE

Sys()[SYS_CONTEXT] := nContext
SETCOLOR(cSavColor)
RESTSCREEN(,,,, KRS(cSavScreen))

RETURN aStru  //  EditStru

//***************************************************************************

PROCEDURE MemvarEdit()

STATIC cSkeleton := '*         '
STATIC cMemFile  := '                                                            '
STATIC cTextFile := '                                                            '
STATIC lAdditive := .Y.
STATIC lCodes    := .N.
STATIC nVar      := 0

LOCAL cSavColor  := SETCOLOR(Sys()[SYS_COLOR][DC_MVBROWSE])
LOCAL nContext   := Sys()[SYS_CONTEXT]
LOCAL nSavRow    := ROW()
LOCAL nSavCol    := COL()
LOCAL cVar       := '          '
LOCAL cVal       := SPACE(180)
LOCAL xVal       := NIL
LOCAL xEval      := NIL
LOCAL cType      := 'C'
LOCAL cLen       := SPACE(5)
LOCAL cDisp      := ''
LOCAL nPos       := 0
LOCAL cMemPath   := ''
LOCAL cLike      := 'L'
LOCAL lLike      := .Y.
LOCAL nWidth     := 0
LOCAL aTypes     := {'C', 'N', 'D', 'L', 'B'}
LOCAL GetList    := {}
LOCAL nBottom    := MAXROW() - 1
LOCAL oVar       := TBROWSENEW(3, 3, nBottom-4, 76)
LOCAL oCol       := NIL
LOCAL nKey       := 0
LOCAL nApply     := 0
LOCAL lBrowse    := .Y.
LOCAL lCalc      := .Y.
LOCAL cSearch    := ''
LOCAL cBottom    := SAVESCREEN(nBottom-2, 2, nBottom, 77)
LOCAL aBox       := ;
  McBox({2, 2, nBottom-3, 77, .Y., .N.,,,,, .Y., .N.}, 'MEMVAR')

//   HOME Restore     END Save     INS Add     DEL Release     ENTER Edit   |
//   Alt-Eval          CTRL-DEL Release all          CTRL-ENTER Edit memo   |
//   Alt-Input text       Alt-Output text       Alt-Refresh      ESC Exit   |
LOCAL aKeyPad := { ;
  {nBottom-2,  6, nBottom-2, 17, K_INS  , .Y., 'HOME ' , 'Restore'}, ;
  {nBottom-2, 23, nBottom-2, 30, K_INS  , .Y., 'END '  , 'Save'   }, ;
  {nBottom-2, 36, nBottom-2, 42, K_INS  , .Y., 'INS '  , 'Add'    }, ;
  {nBottom-2, 48, nBottom-2, 58, K_DEL  , .Y., 'DEL '  , 'Delete' }, ;
  {nBottom-2, 64, nBottom-2, 73, K_ENTER, .Y., 'ENTER ', 'Edit'   }, ;
  {nBottom-1,  6, nBottom-1, 13, K_ALT_E, .Y., 'Alt-E' , 'val'    }, ;
  {nBottom-1, 24, nBottom-1, 43, K_DEL  , .Y., ;
  'CTRL-DEL '  , 'Release all'}, ;
  {nBottom-1, 54, nBottom-1, 73, K_ENTER, .Y., ;
  'CTRL-ENTER ', 'Edit memo'  }, ;
  {nBottom  ,  6, nBottom  , 19, K_ALT_E, .Y., 'Alt-I' , 'nput text' }, ;
  {nBottom  , 27, nBottom  , 41, K_ALT_E, .Y., 'Alt-O' , 'ouput text'}, ;
  {nBottom  , 49, nBottom  , 59, K_ALT_E, .Y., 'Alt-R' , 'efresh'    }, ;
  {nBottom  , 66, nBottom  , 73, K_ESC  , .Y., 'ESC '  , 'Exit'      }  }

@ nBottom-2, 2 CLEAR TO nBottom, 77
SayInitial(aKeyPad)

oCol := TBCOLUMNNEW('Name', ;
  {|| IF(EMPTY(Sys()[SYS_MEMVAR]), '', Sys()[SYS_MEMVAR][nVar][1])})
oCol:WIDTH := 10
oVar:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Type', ;
  {|| IF(EMPTY(Sys()[SYS_MEMVAR]), '', Sys()[SYS_MEMVAR][nVar][2])})
oCol:WIDTH := 4
oVar:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Length', ;
  {|| IF(EMPTY(Sys()[SYS_MEMVAR]), '', STR(Sys()[SYS_MEMVAR][nVar][3], 6))})
oCol:WIDTH := 6
oVar:ADDCOLUMN(oCol)
oCol := TBCOLUMNNEW('Expression', ;
  {|| IF(EMPTY(Sys()[SYS_MEMVAR]), '', ;
  EvalDisp(Sys()[SYS_MEMVAR][nVar][4], 50))})
oCol:WIDTH := 50
oVar:ADDCOLUMN(oCol)
oVar:GOTOPBLOCK    := {|| nVar := MIN(LEN(Sys()[SYS_MEMVAR]), 1)}
oVar:GOBOTTOMBLOCK := {|| nVar := LEN(Sys()[SYS_MEMVAR])}
oVar:SKIPBLOCK     := {|nSkip, nVarOld| nVarOld := nVar, ;
  (nVar := MIN(MAX(nVar + nSkip, 1), LEN(Sys()[SYS_MEMVAR]))) - nVarOld}
oVar:HEADSEP       := C_SS_T_TOP + C_S_HORIZ
oVar:COLSEP        := C_S_VERT

WHILE lBrowse

  IF lCalc
    oVar:REFRESHALL()
    CenterStable(oVar, {4, 4, 1, 2}, {|| nVar}, LEN(Sys()[SYS_MEMVAR]),, 4)
    Sys()[SYS_MEMREFRESH] := .Y.
    lCalc := .N.
  END

  nKey   := McTransPad(aKeyPad, INKEY(0))
  nApply := ;
    IncSeaApply(oVar, 1, 4, nKey, @cSearch, Sys()[SYS_MEMVAR],, ;
    {|aRow, cGet| LEFT(aRow[1], LEN(cGet))}, ;
    {|| nVar}, {|nVal| nVar := nVal}, {|aRow, cGet| LEN(cGet)}, {4, 4, 1, 2})

  BEGIN SEQUENCE

    DO CASE
    CASE nKey == K_HOME

      Sys()[SYS_CONTEXT] := H_MEMREST
      BoxGet('RESTORE VARIABLES FROM MEM FILE', BT_DIR, { ;
        {'Name:', cMemFile, {|cGet| cMemFile := cGet}, '@F', '.MEM'}, ;
        {'Additive:', lAdditive, {|lGet| lAdditive := lGet}}})
      IF EMPTY(cMemFile) .OR. LASTKEY() == K_ESC
        BREAK
      END
      BoxStatus('Restoring...',,, Sys()[SYS_COLOR][DC_MVSTATUS])
      cMemPath := PathAdj(cMemFile, .Y.)
      IF lAdditive
        __MRESTORE(cMemPath, .Y.)
      ELSE
        Sys()[SYS_MEMVAR] := {}
        __MRESTORE(cMemPath, .N.)
      END
      ReadMem(cMemFile)
      nVar  := 1
      lCalc := .Y.
      BoxStatus()

    CASE nKey == K_END

      Sys()[SYS_CONTEXT] := H_MEMSAVE
      BoxGet('SAVE VARIABLES TO MEM FILE', BT_DIR, { ;
        {'Name:', cMemFile, {|cGet| cMemFile := cGet}, '@F', '.MEM'}, ;
        {'Like or Except:', cLike, {|cGet| cLike := cGet}, '!'}, ;
        {'Skeleton:', cSkeleton, {|cGet| cSkeleton := cGet}, '@!'}})
      IF EMPTY(cMemFile) .OR. LASTKEY() == K_ESC
        BREAK
      END
      IF !(cLike == 'L' .OR. cLike == 'E')
        ALERT('Enter L for Like or E for Except.')
        BREAK
      END
      BoxStatus('Saving...',,, Sys()[SYS_COLOR][DC_MVSTATUS])
      cMemPath := PathAdj(cMemFile, .Y.)
      lLike    := cLike == 'L'
      DO CASE
      CASE lLike .AND. EMPTY(cSkeleton)
        SAVE TO (cMemPath)
      CASE lLike .AND. !EMPTY(cSkeleton)
        SAVE TO (cMemPath) ALL LIKE (cSkeleton)
      CASE !lLike .AND. !EMPTY(cSkeleton)
        SAVE TO (cMemPath) ALL EXCEPT (cSkeleton)
      END
      COMMIT
      BoxStatus()

    CASE nKey == K_ENTER .OR. nApply == K_DOUBLECLICK

      xVal   := Sys()[SYS_MEMVAR][nVar][4]
      nWidth := oVar:GETCOLUMN(4):WIDTH
      cVal   := PADR(EvalDisp(xVal), 180)
      oVar:REFRESHCURRENT()
      CenterStable(oVar, {4, 4, 1, 2}, {|| nVar}, LEN(Sys()[SYS_MEMVAR]),, 4)
      SETCOLOR(Sys()[SYS_COLOR][DC_MVEDIT])
      @ ROW(), COL() GET cVal PICTURE '@S' + ALLTRIM(STR(nWidth))
      READ
      IF LASTKEY() == K_ESC
        BREAK
      END
      cType := TYPE(cVal)
      IF EMPTY(ASCAN(aTypes, cType))
        ALERT('Unknown data type on ' + cVar)
        BREAK
      END
      xVal  := &cVal
      Sys()[SYS_MEMVAR][nVar][2] := cType
      Sys()[SYS_MEMVAR][nVar][3] := IF(cType == 'C', LEN(xVal), 0)
      Sys()[SYS_MEMVAR][nVar][4] := xVal
      MEMVARBLOCK(Sys()[SYS_MEMVAR][nVar][1]):EVAL(xVal)
      lCalc := .Y.

    CASE nKey == K_CTRL_ENTER

      xVal  := Sys()[SYS_MEMVAR][nVar][4]
      cType := VALTYPE(xVal)
      IF cType # 'C'
        ALERT('Current memvar is not a character variable.')
        BREAK
      END
      nWidth := oVar:GETCOLUMN(4):WIDTH
      xVal   := MemoGet(xVal,, .N., Sys()[SYS_COLOR][DC_MVEDIT])
      Sys()[SYS_MEMVAR][nVar][3] := LEN(xVal)
      Sys()[SYS_MEMVAR][nVar][4] := xVal
      MEMVARBLOCK(Sys()[SYS_MEMVAR][nVar][1]):EVAL(xVal)
      lCalc := .Y.

    CASE nKey == K_INS

      Sys()[SYS_CONTEXT] := H_MEMADD
      BoxGet('INSERT NEW VARIABLE',, { ;
        {'Name:', cVar, {|cGet| cVar := cGet}, '!!!!!!!!!!'}, ;
        {'Expression:', cVal, {|cGet| cVal := cGet}, '@S60'}})
      IF EMPTY(cVar) .OR. LASTKEY() == K_ESC
        BREAK
      END
      xVal  := &cVal
      cType := VALTYPE(xVal)
      IF EMPTY(ASCAN(aTypes, cType))
        ALERT('Unknown data type on ' + cVar)
        BREAK
      END
      PRIVATE &cVar := xVal
      AADD(Sys()[SYS_MEMVAR], ;
        {cVar, cType, IF(cType == 'C', LEN(xVal), 0), xVal})
      ASORT(Sys()[SYS_MEMVAR],,, {|aLine1, aLine2| aLine1[1] < aLine2[1]})
      nVar  := 1
      lCalc := .Y.

    CASE nKey == K_DEL

      IF EMPTY(Sys()[SYS_MEMVAR])
        BREAK
      END
      cVar := Sys()[SYS_MEMVAR][nVar][1]
      IF !YesNo('Release memvar ' + cVar + '?', .Y.)
        BREAK
      END
      RELEASE &cVar
      ADEL(Sys()[SYS_MEMVAR], nVar)
      ASIZE(Sys()[SYS_MEMVAR], LEN(Sys()[SYS_MEMVAR]) - 1)
      lCalc := .Y.

    CASE nKey == K_CTRL_DEL .OR. nKey == K_CTRL_END

      IF !YesNo('Release all memvars?', .Y.)
        BREAK
      END
      RELEASE ALL
      Sys()[SYS_MEMVAR] := {}
      nVar  := 0
      lCalc := .Y.

    CASE nKey == K_ALT_E

      xVal  := Sys()[SYS_MEMVAR][nVar][4]
      cType := VALTYPE(xVal)
      IF cType # 'B'
        ALERT('Current memvar is not a code block.')
        BREAK
      END
      xEval := xVal:EVAL()
      ALERT(EvalDisp(xEval, 76),, Sys()[SYS_COLOR][DC_STATUS])

    CASE nKey == K_ALT_I

      Sys()[SYS_CONTEXT] := H_MEMINPUT
      BoxGet('INPUT VARIABLES FROM TEXT FILE', BT_DIR, { ;
        {'Name:', cTextFile, {|cGet| cTextFile := cGet}, '@F', '.TXT'}})
      IF EMPTY(cTextFile) .OR. LASTKEY() == K_ESC
        BREAK
      END
      BoxStatus('Inputting...',,, Sys()[SYS_COLOR][DC_MVSTATUS])
      BEGIN SEQUENCE
        DBCREATE(PathAdj('DBETemp', .Y.), {{'Line', 'C', 80, 0}})
        DBUSEAREA(.Y.,, PathAdj('DBETemp', .Y.))
        APPEND FROM (PathAdj(cTextFile, .Y.)) SDF
        GO TOP
        WHILE !EOF()
          nPos  := AT(' ', DBETemp->Line)
          cVar  := UPPER(LEFT(DBETemp->Line, nPos - 1))
          cVal  := ALLTRIM(SUBSTR(DBETemp->Line, nPos + 1))
          cType := UPPER(LEFT(cVal, 1))
          nPos  := AT(' ', cVal)
          cVal  := ALLTRIM(SUBSTR(cVal, nPos + 1))
          IF cType == 'C'
            nPos  := AT(' ', cVal)
            cLen  := UPPER(LEFT(cVal, nPos - 1))
            cVal  := ALLTRIM(SUBSTR(cVal, nPos + 1))
          END
          xVal  := &cVal
          DO CASE
          CASE EMPTY(ASCAN(aTypes, cType))
            ALERT('Unknown data type on ' + cVar)
          CASE VALTYPE(xVal) # cType
            ALERT('Data type mismatch on ' + cVar)
          CASE cType == 'C' .AND. LEN(xVal) # VAL(cLen)
            ALERT('Character length mismatch on ' + cVar)
          OTHERWISE
            PRIVATE &cVar := xVal
            AADD(Sys()[SYS_MEMVAR], ;
              {cVar, cType, IF(cType == 'C', LEN(xVal), 0), xVal})
          END
          SKIP
        END
      END SEQUENCE
      CLOSE DBETemp
      IF !EMPTY(Current())
        SELECT (Current()[DATA_ALIAS])
      END
      ERASE (PathAdj('DBETemp', .Y.))
      ASORT(Sys()[SYS_MEMVAR],,, {|aLine1, aLine2| aLine1[1] < aLine2[1]})
      nVar  := 1
      lCalc := .Y.
      BoxStatus()

    CASE nKey == K_ALT_O

      Sys()[SYS_CONTEXT] := H_MEMOUTPUT
      BoxGet('OUTPUT VARIABLES TO TEXT FILE', BT_DIR, { ;
        {'Name:', cTextFile, {|cGet| cTextFile := cGet}, '@F', '.TXT'}, ;
        {'Additive:', lAdditive, {|lGet| lAdditive := lGet}}, ;
        {'Printer codes:', lCodes, {|lGet| lCodes := lGet}}})
      IF EMPTY(cTextFile) .OR. LASTKEY() == K_ESC
        BREAK
      END
      PrintInit(lCodes)
      BoxStatus('Outputting...',,, Sys()[SYS_COLOR][DC_MVSTATUS])
      PrintSet(.Y., cTextFile, lAdditive)
      BEGIN SEQUENCE
        QQOUT(PrintCodes(lCodes, .Y.))
        FOR nPos := 1 TO LEN(Sys()[SYS_MEMVAR])
          cVar  := Sys()[SYS_MEMVAR][nPos][1]
          xVal  := MEMVARBLOCK(cVar):EVAL()
          cType := VALTYPE(xVal)
          cLen  := IF(cType == 'C', STR(LEN(xVal),5), SPACE(5))
          cDisp := EvalDisp(xVal, 0)
          QLine(PADR(cVar, 10) + ' ' + cType + ' ' + cLen + ' ' + cDisp)
        NEXT
        QQOUT(PrintCodes(lCodes, .N.))
      END SEQUENCE
      PrintSet(.N.)
      BoxStatus()

    CASE nKey == K_ALT_R

      lCalc := .Y.

    CASE nKey == K_ESC .OR. nApply == TA_CLOSE

      IF !YesNo('Exit the memvar editor?', .Y.)
        BREAK
      END
      lBrowse := .N.

    END

  END SEQUENCE

  BoxStatus()
  Sys()[SYS_CONTEXT] := nContext

END

McRestBox(aBox)
RESTSCREEN(nBottom, 2, nBottom, 77, cBottom)
SETCOLOR(cSavColor)
SETPOS(nSavRow, nSavCol)

RETURN  //  MemvarEdit

//***************************************************************************

PROCEDURE EditFRM(cFRMName)

/*

02----------------------------- MODIFY REPORT ------------------------------+
03 Heading     ____________________________________________________________ |
04             ____________________________________________________________ |
05 Parameters         Set page width ___         Lines per page ___         |
06                       Left margin ___           Double space _           |
07                      Right margin ___     Eject before print _           |
08             Computed column width ___      Eject after print _           |
09              Computed total width ___            Plain print _           |
10 Group       ________________________________________      Summary only _ |
11             ________________________________________ Eject after group _ |
12 Columns    +------------------------------------------------------------+|
13            |  # Heading                Expression                 Width ||
14            |___ ______________________ __________________________ _____ ||
15            |___ ______________________ __________________________ _____ ||
16            |___ ______________________ __________________________ _____ ||
17            |___ ______________________ __________________________ _____ ||
18            |___ ______________________ __________________________ _____ ||
19            |___ ______________________ __________________________ _____ ||
20            +------------------------------------------------------------+|
21--------------------------------------------------------------------------+
22 INS Add column   DEL Delete column    ENTER Edit column   Formats   List
23 Ctrl-^ Move column up   Ctrl-V Move column down    END Save   ESC Cancel

02----------------------------- MODIFY REPORT ------------------------------+
03                                                                          |
04 Heading     ____________________________________________________________ |
05             ____________________________________________________________ |
06             ____________________________________________________________ |
07             ____________________________________________________________ |
08                                                                          |
09 Parameters         Set page width ___         Lines per page ___         |
10                       Left margin ___           Double space _           |
11                      Right margin ___     Eject before print _           |
12             Computed column width ___      Eject after print _           |
13              Computed total width ___            Plain print _           |
14                                                                          |
15 Group       ________________________________________      Summary only _ |
16             ________________________________________ Eject after group _ |
17             ________________________________________                     |
18             ________________________________________                     |
19                                                                          |
20 Columns    +------------------------------------------------------------+|
21            |  # Heading                Expression                 Width ||
22            |___ ______________________ __________________________ _____ ||
23            |___ ______________________ __________________________ _____ ||
24            |___ ______________________ __________________________ _____ ||
25            |___ ______________________ __________________________ _____ ||
26            |___ ______________________ __________________________ _____ ||
27            |___ ______________________ __________________________ _____ ||
28            |___ ______________________ __________________________ _____ ||
29            |___ ______________________ __________________________ _____ ||
30            |___ ______________________ __________________________ _____ ||
31            |___ ______________________ __________________________ _____ ||
32            |___ ______________________ __________________________ _____ ||
33            |___ ______________________ __________________________ _____ ||
34            |___ ______________________ __________________________ _____ ||
35            |___ ______________________ __________________________ _____ ||
36            |___ ______________________ __________________________ _____ ||
37            |___ ______________________ __________________________ _____ ||
38            |___ ______________________ __________________________ _____ ||
39            |___ ______________________ __________________________ _____ ||
40            |___ ______________________ __________________________ _____ ||
41            |___ ______________________ __________________________ _____ ||
42            |___ ______________________ __________________________ _____ ||
43            |___ ______________________ __________________________ _____ ||
44            +------------------------------------------------------------+|
45                                                                          |
46--------------------------------------------------------------------------+
47 INS Add column   DEL Delete column    ENTER Edit column   Formats   List
48 Ctrl-^ Move column up   Ctrl-V Move column down    END Save   ESC Cancel

*/

STATIC cTextFile := '                                                            '
STATIC lAdditive := .Y.
STATIC lCodes    := .N.

LOCAL cSavColor  := SETCOLOR(Sys()[SYS_COLOR][DC_MVBROWSE])
LOCAL nSavRow    := ROW()
LOCAL nSavCol    := COL()
LOCAL nContext   := Sys()[SYS_CONTEXT]
LOCAL cFRMFile   := PathAdj(cFRMName,, '.FRM', .Y.)
LOCAL aReport    := ReadFRM(cFRMFile, .N.)
LOCAL aHeading   := ACLONE(aReport[RP_HEADER])
LOCAL aCol       := ACLONE(aReport[RP_COLUMNS])
LOCAL nCol       := 1
LOCAL aGroup     := ACLONE(aReport[RP_GROUPS])
LOCAL cGrpHead   := PADR(aGroup[1][RG_HEADER], 60)
LOCAL cGrpExp    := PADR(aGroup[1][RG_TEXT  ], 200)
LOCAL lGrpSum    := aReport[RP_SUMMARY ]
LOCAL lGrpEject  := aGroup[1][RG_AEJECT]
LOCAL cSubHead   := PADR(aGroup[2][RG_HEADER], 60)
LOCAL cSubExp    := PADR(aGroup[2][RG_TEXT  ], 200)
LOCAL nSetWidth  := aReport[RP_WIDTH   ]
LOCAL nColWidth  := 0
LOCAL nTotWidth  := 0
LOCAL nLMargin   := aReport[RP_LMARGIN ]
LOCAL nRMargin   := aReport[RP_RMARGIN ]
LOCAL nVLines    := aReport[RP_LINES   ]
LOCAL lDouble    := aReport[RP_DBLSPACE]
LOCAL lBEject    := aReport[RP_BEJECT  ]
LOCAL lAEject    := aReport[RP_AEJECT  ]
LOCAL lPlain     := aReport[RP_PLAIN   ]
LOCAL lSummary   := aReport[RP_SUMMARY ]
LOCAL aColRow    := {}
LOCAL aColRow1   := {}
LOCAL aColRow2   := {}
LOCAL aColHead   := ARRAY(4)
LOCAL cColExp    := SPACE(200)
LOCAL nColLen    := 0
LOCAL nColDec    := 0
LOCAL lColTot    := .N.
LOCAL nKey       := 0
LOCAL cKey       := ''
LOCAL nApply     := 0
LOCAL lBrowse    := .Y.
LOCAL lSave      := .N.
LOCAL lCalc      := .Y.
LOCAL lSayHead   := .Y.
LOCAL lSayParam  := .Y.
LOCAL lSayGroup  := .Y.
LOCAL lMaxLine   := MAXROW() > 24
LOCAL nTop       := 2
LOCAL nHeadTop   := nTop     + IF(!lMaxLine, 1, 2)
LOCAL nHeadBot   := nHeadTop + IF(!lMaxLine, 1, 3)
LOCAL nParTop    := nHeadBot + IF(!lMaxLine, 1, 2)
LOCAL nParBot    := nParTop  + 4
LOCAL nGrpTop    := nParBot  + IF(!lMaxLine, 1, 2)
LOCAL nGrpBot    := nGrpTop  + IF(!lMaxLine, 1, 3)
LOCAL nColTop    := nGrpBot  + IF(!lMaxLine, 1, 2)
LOCAL nColBot    := MAXROW() - IF(!lMaxLine, 4, 5)
LOCAL nBottom    := MAXROW() - 1
LOCAL cBottom    := SAVESCREEN(nBottom - 1, 2, nBottom, 77)
LOCAL aSavBox    := McBox({nTop, 2, nBottom - 2, 77}, cFRMFile)
LOCAL aColBox    := McBox({nColTop, 15, nColBot, 76, .Y., .Y.,,,,, .Y., .Y.})
LOCAL oCol       := TBROWSENEW(nColTop + 1, 16, nColBot - 1, 75)
LOCAL oBroCol    := NIL
LOCAL aPaper     := {'Letter', 'Legal'}
LOCAL aOrient    := {'Portrait', 'Landscape'}
LOCAL aPitch     := {'10', '12', '16'}
LOCAL aLPI       := {'6', '8'}
LOCAL nPaper     := 1
LOCAL nOrient    := 1
LOCAL nPitch     := 1
LOCAL nLPI       := 1
LOCAL aSetWidth  := { ;
  { { 80,  96, 134},    ;
    {106, 128, 177}  }, ;
  { { 80,  96, 134},    ;
    {136, 164, 227}  }  }
LOCAL aVLines    := { ;
  { { 57,  76},    ;
    { 42,  56}  }, ;
  { { 75, 100},    ;
    { 42,  56}  }  }
LOCAL aKeyPad    := {}

AEVAL({ ;
  {nHeadTop ,  4, nParTop-1, 75, 'H'        , .Y.,    ;
  'H'                          , 'eading'          }, ;
  {nParTop  ,  4, nGrpTop-1, 75, 'P'        , .Y.,    ;
  'P'                          , 'arameters'       }, ;
  {nGrpTop  ,  4, nColTop-1, 75, 'G'        , .Y.,    ;
  'G'                          , 'roup'            }, ;
  {nColTop  ,  4, nColBot  , 75, 'C'        , .Y.,    ;
  'C'                          , 'olumns'          }  }, ;
  {|aRow| AADD(aKeyPad, ACLONE(aRow))})
AEVAL({ ;
  {nBottom-1,  4, nBottom-1, 17, K_INS      , .Y.,    ;
  'INS '                       , 'Add column'      }, ;
  {nBottom-1, 21, nBottom-1, 37, K_DEL      , .Y.,    ;
  'DEL '                       , 'Delete column'   }, ;
  {nBottom-1, 42, nBottom-1, 58, K_ENTER    , .Y.,    ;
  'ENTER '                     , 'Edit column'     }, ;
  {nBottom-1, 62, nBottom-1, 68, 'F'        , .Y.,    ;
  'F'                          , 'ormats'          }, ;
  {nBottom-1, 72, nBottom-1, 75, 'L'        , .Y.,    ;
  'L'                          , 'ist'             }  }, ;
  {|aRow| AADD(aKeyPad, ACLONE(aRow))})
AEVAL({ ;
  {nBottom  ,  4, nBottom  , 24, K_CTRL_UP  , .Y.,    ;
  'Ctrl-' + C_UP_ARROW    + ' ', 'Move column up'  }, ;
  {nBottom  , 28, nBottom  , 50, K_CTRL_DOWN, .Y.,    ;
  'Ctrl-' + C_DOWN_ARROW  + ' ', 'Move column down'}, ;
  {nBottom  , 55, nBottom  , 62, K_END      , .Y.,    ;
  'END '                       , 'Save'            }, ;
  {nBottom  , 66, nBottom  , 75, K_ESC      , .Y.,    ;
  'ESC '                       , 'Cancel'          }  }, ;
  {|aRow| AADD(aKeyPad, ACLONE(aRow))})

@ nParTop    , 16 SAY '       Set page width'
@ nParTop + 1, 16 SAY '          Left margin'
@ nParTop + 2, 16 SAY '         Right margin'
@ nParTop + 3, 16 SAY 'Computed column width'
@ nParTop + 4, 16 SAY ' Computed total width'
@ nParTop    , 46 SAY '    Lines per page'
@ nParTop + 1, 46 SAY '      Double space'
@ nParTop + 2, 46 SAY 'Eject before print'
@ nParTop + 3, 46 SAY ' Eject after print'
@ nParTop + 4, 46 SAY '       Plain print'
@ nGrpTop    , 57 SAY '     Summary only'
@ nGrpTop + 1, 57 SAY 'Eject after group'
@ nBottom - 1, 2 CLEAR TO nBottom, 77
SayInitial(aKeyPad)

AEVAL(aHeading, {|cRow, nRow| aHeading[nRow] := PADR(cRow, 60)})

oBroCol := TBCOLUMNNEW('  #', ;
  {|| IF(EMPTY(aCol), '', STR(nCol,3))})
oBroCol:WIDTH := 3
oCol:ADDCOLUMN(oBroCol)
oBroCol := TBCOLUMNNEW('Heading', ;
  {|| IF(EMPTY(aCol), '', aCol[nCol][RC_HEADTEXT])})
oBroCol:WIDTH := 22
oCol:ADDCOLUMN(oBroCol)
oBroCol := TBCOLUMNNEW('Expression', ;
  {|| IF(EMPTY(aCol), '', aCol[nCol][RC_TEXT])})
oBroCol:WIDTH := 26
oCol:ADDCOLUMN(oBroCol)
oBroCol := TBCOLUMNNEW('  Len', ;
  {|| IF(EMPTY(aCol), '', STR(aCol[nCol][RC_WIDTH], 5))})
oBroCol:WIDTH := 5
oCol:ADDCOLUMN(oBroCol)
oBroCol := TBCOLUMNNEW('  Dec', ;
  {|| IF(EMPTY(aCol), '', STR(aCol[nCol][RC_DECIMALS], 5))})
oBroCol:WIDTH := 5
oCol:ADDCOLUMN(oBroCol)
oBroCol := TBCOLUMNNEW('Total', ;
  {|| IF(EMPTY(aCol), '', PADC(TRANSFORM(aCol[nCol][RC_TOTAL], 'Y'), 5))})
oBroCol:WIDTH := 5
oCol:ADDCOLUMN(oBroCol)
oCol:GOTOPBLOCK    := {|| nCol := 1}
oCol:GOBOTTOMBLOCK := {|| nCol := MAX(1, LEN(aCol))}
oCol:SKIPBLOCK     := {|nSkip, nColOld| nColOld := nCol, ;
  (nCol := MAX(MIN(nCol + nSkip, LEN(aCol)), 1)) - nColOld}

WHILE lBrowse

  IF lCalc
    nColWidth := 0
    AEVAL(aCol, {|aColRow, nColRow| nColWidth := nColWidth + ;
      aColRow[RC_WIDTH] + IF(nColRow == 1, 0, 1)})
    nTotWidth := nColWidth + nLMargin + nRMargin
    lCalc     := .N.
    lSayParam := .Y.
  END

  IF lSayHead
    COLORSELECT(3)
    @ nHeadTop    , 16 SAY aHeading[1]
    @ nHeadTop + 1, 16 SAY aHeading[2]
    IF lMaxLine
      @ nHeadTop + 2, 16 SAY aHeading[3]
      @ nHeadTop + 3, 16 SAY aHeading[4]
    END
    COLORSELECT(0)
    lSayHead := .N.
  END

  IF lSayParam
    COLORSELECT(3)
    @ nParTop    , 38 SAY TRANSFORM(nSetWidth, '999')
    @ nParTop + 1, 38 SAY TRANSFORM(nLMargin , '999')
    @ nParTop + 2, 38 SAY TRANSFORM(nRMargin , '999')
    @ nParTop + 3, 38 SAY TRANSFORM(nColWidth, '999')
    @ nParTop + 4, 38 SAY TRANSFORM(nTotWidth, '999')
    @ nParTop    , 65 SAY TRANSFORM(nVLines  , '999')
    @ nParTop + 1, 65 SAY TRANSFORM(lDouble  , 'Y')
    @ nParTop + 2, 65 SAY TRANSFORM(lBEject  , 'Y')
    @ nParTop + 3, 65 SAY TRANSFORM(lAEject  , 'Y')
    @ nParTop + 4, 65 SAY TRANSFORM(lPlain   , 'Y')
    COLORSELECT(0)
    lSayParam := .N.
  END

  IF lSayGroup
    COLORSELECT(3)
    @ nGrpTop    , 75 SAY TRANSFORM(lGrpSum  , 'Y')
    @ nGrpTop + 1, 75 SAY TRANSFORM(lGrpEject, 'Y')
    @ nGrpTop    , 16 SAY PADL(cGrpHead, 40)
    @ nGrpTop + 1, 16 SAY PADL(cGrpExp , 40)
    IF lMaxLine
      @ nGrpTop + 2, 16 SAY PADL(cSubHead, 40)
      @ nGrpTop + 3, 16 SAY PADL(cSubExp , 40)
    END
    COLORSELECT(0)
    lSayGroup := .N.
  END

  CenterStable(oCol, {4, 4, 1, 2}, {|| nCol}, LEN(aCol), .Y.)
  nKey   := McTransPad(aKeyPad, INKEY(0))
  cKey   := UPPER(CHR(nKey))
  nApply := McTBApplyKey(oCol, nKey)

  DO CASE
  CASE cKey == 'H'

    Sys()[SYS_CONTEXT] := H_FRMHEAD
    BoxGet('REPORT HEADING',, { ;
      {'Heading lines:', aHeading, {|aVal| aHeading := ACLONE(aVal)}}})
    lSayHead := .Y.

  CASE cKey == 'P'

    Sys()[SYS_CONTEXT] := H_FRMPARAM
    BoxGet('REPORT PARAMETERS',, { ;
      {'Set page width:', nSetWidth, {|nVal| nSetWidth := nVal}, '999'}, ;
      {'Left margin:'   , nLMargin , {|nVal| nLMargin  := nVal}, '999'}, ;
      {'Right margin:'  , nRMargin , {|nVal| nRMargin  := nVal}, '999'}, ;
      {'Lines per page:', nVLines  , {|nVal| nVLines   := nVal}, '999'}, ;
      {'Double space:'      , lDouble, {|lVal| lDouble := lVal}}, ;
      {'Eject before print:', lBEject, {|lVal| lBEject := lVal}}, ;
      {'Eject after print:' , lAEject, {|lVal| lAEject := lVal}}, ;
      {'Plain print:'       , lPlain , {|lVal| lPlain  := lVal}}})
    lSayParam := .Y.
    lCalc     := .Y.

  CASE cKey == 'G'

    Sys()[SYS_CONTEXT] := H_FRMGROUP
    BoxGet('REPORT GROUP AND SUBGROUP', BT_STRUC, { ;
      {'Group heading:'      , cGrpHead , {|cVal| cGrpHead  := cVal}}, ;
      {'Group expression:'   , cGrpExp  , {|cVal| cGrpExp   := cVal}, ;
      '@S60'}, ;
      {'Summary only:'       , lGrpSum  , {|lVal| lGrpSum   := lVal}}, ;
      {'Eject after group:'  , lGrpEject, {|lVal| lGrpEject := lVal}}, ;
      {'Subgroup heading:'   , cSubHead , {|cVal| cSubHead  := cVal}}, ;
      {'Subgroup expression:', cSubExp  , {|cVal| cSubExp   := cVal}, ;
      '@S60'}})
    lSayGroup := .Y.

  CASE cKey == 'C'

    oCol:REFRESHALL()
    lCalc := .Y.

  CASE nKey == K_INS

    Sys()[SYS_CONTEXT] := H_FRMCOLADD
    AEVAL(aColHead, {|cRow, nRow| ;
      aColHead[nRow] := PADR(IF(cRow == NIL, '', cRow), 60)})
    BoxGet('ADD REPORT COLUMN', BT_STRUC, { ;
      {'Heading:'   , aColHead, {|aVal| aColHead := ACLONE(aVal)}}, ;
      {'Expression:', cColExp , {|cVal| cColExp  := cVal}, '@S60'}, ;
      {'Length:'    , nColLen , {|nVal| nColLen  := nVal}, '99'}, ;
      {'Decimals:'  , nColDec , {|nVal| nColDec  := nVal}, '99'}, ;
      {'Total:'     , lColTot , {|lVal| lColTot  := lVal}}})
    IF !(EMPTY(cColExp) .OR. EMPTY(nColLen) .OR. LASTKEY() == K_ESC)
      aColRow := ARRAY(RC_COUNT)
      AEVAL(aColHead, {|cRow, nRow| aColHead[nRow] := ALLTRIM(cRow)})
      aColRow[RC_HEADTEXT] := ListArray(aColHead, ';')
      aColRow[RC_HEADER]   := aColHead
      aColRow[RC_TEXT    ] := ALLTRIM(cColExp)
      aColRow[RC_WIDTH   ] := nColLen
      aColRow[RC_DECIMALS] := nColDec
      aColRow[RC_TOTAL   ] := lColTot
      AADD(aCol, ACLONE(aColRow))
      nCol := LEN(aCol)
      oCol:REFRESHALL()
      lCalc := .Y.
    END

  CASE nKey == K_DEL .AND. YesNo('Delete this column?', .Y.)

    ADEL(aCol, nCol)
    ASIZE(aCol, LEN(aCol) - 1)
    oCol:REFRESHALL()
    lCalc := .Y.

  CASE (nKey == K_ENTER .OR. nApply == K_DOUBLECLICK) .AND. !EMPTY(aCol)

    Sys()[SYS_CONTEXT] := H_FRMCOLEDIT
    aColRow  := ACLONE(aCol[nCol])
    aColHead := aColRow[RC_HEADER]
    ASIZE(aColHead, 4)
    AEVAL(aColHead, {|cRow, nRow| ;
      aColHead[nRow] := PADR(IF(cRow == NIL, '', cRow), 60)})
    cColExp  := PADR(aColRow[RC_TEXT  ], 200)
    nColLen  := aColRow[RC_WIDTH   ]
    nColDec  := aColRow[RC_DECIMALS]
    lColTot  := aColRow[RC_TOTAL   ]
    BoxGet('EDIT REPORT COLUMN', BT_STRUC, { ;
      {'Heading:'   , aColHead, {|aVal| aColHead := ACLONE(aVal)}}, ;
      {'Expression:', cColExp , {|cVal| cColExp  := cVal}, '@S60'}, ;
      {'Length:'    , nColLen , {|nVal| nColLen  := nVal}, '99'}, ;
      {'Decimals:'  , nColDec , {|nVal| nColDec  := nVal}, '99'}, ;
      {'Total:'     , lColTot , {|lVal| lColTot  := lVal}}})
    IF !(EMPTY(cColExp) .OR. EMPTY(nColLen) .OR. LASTKEY() == K_ESC)
      AEVAL(aColHead, {|cRow, nRow| aColHead[nRow] := ALLTRIM(cRow)})
      aColRow[RC_HEADTEXT] := ListArray(aColHead, ';')
      aColRow[RC_HEADER]   := aColHead
      aColRow[RC_TEXT]     := ALLTRIM(cColExp)
      aColRow[RC_WIDTH]    := nColLen
      aColRow[RC_DECIMALS] := nColDec
      aColRow[RC_TOTAL]    := lColTot
      aCol[nCol] := ACLONE(aColRow)
      oCol:REFRESHCURRENT()
      lCalc := .Y.
    END

  CASE cKey == 'F'

    Sys()[SYS_CONTEXT] := H_FRMFORM
    BoxGet('REPORT FORMATS',, { ;
      {'Paper size:', nPaper, {|nVal| nPaper := nVal}, aPaper}, ;
      {'Orientation:', nOrient, {|nVal| nOrient := nVal}, aOrient}, ;
      {'Pitch:', nPitch, {|nVal| nPitch := nVal}, aPitch}, ;
      {'Lines per inch:', nLPI, {|nVal| nLPI := nVal}, aLPI}})
    IF LASTKEY() == K_ESC
      BREAK
    END
    nSetWidth := aSetWidth[nPaper][nOrient][nPitch]
    nVLines   := aVLines[nPaper][nOrient][nLPI]
    lSayParam := .Y.

  CASE cKey == 'L'

    Sys()[SYS_CONTEXT] := H_FRMLIST
    BoxGet('LIST REPORT FILE',, { ;
      {'To:', cTextFile, {|cVal| cTextFile := cVal}, '@F', '.TXT'}, ;
      {'Additive:', lAdditive, {|lVal| lAdditive := lVal}}, ;
      {'Printer codes:', lCodes, {|lVal| lCodes := lVal}}})
    IF EMPTY(cTextFile) .OR. LASTKEY() == K_ESC
      BREAK
    END
    PrintInit(lCodes)
    BoxStatus('Listing...')
    PrintSet(.Y., cTextFile, lAdditive)
    BEGIN SEQUENCE
      QQOUT(PrintCodes(lCodes, .Y.))
      QQOUT(ListFRM(cFRMFile, aHeading, aCol, ;
        cGrpHead, cGrpExp, lGrpSum, lGrpEject, cSubHead, cSubExp, ;
        nSetWidth, nLMargin, nRMargin, nColWidth, nTotWidth, nVLines, ;
        lDouble, lBEject, lAEject, lPlain, lSummary))
      QQOUT(PrintCodes(lCodes, .N.))
    END SEQUENCE
    PrintSet(.N.)
    BoxStatus()

  CASE (nKey == K_CTRL_UP .OR. nKey == K_ALT_U) .AND. ;
    nCol >= 2 .AND. LEN(aCol) >= 2

    aColRow1 := ACLONE(aCol[nCol  ])
    aColRow2 := ACLONE(aCol[nCol-1])
    aCol[nCol-1] := ACLONE(aColRow1)
    aCol[nCol  ] := ACLONE(aColRow2)
    oCol:UP()
    oCol:REFRESHALL()

  CASE (nKey == K_CTRL_DOWN .OR. nKey == K_ALT_B) .AND. ;
    nCol <= LEN(aCol)-1 .AND. LEN(aCol) >= 2

    aColRow1 := ACLONE(aCol[nCol  ])
    aColRow2 := ACLONE(aCol[nCol+1])
    aCol[nCol+1] := ACLONE(aColRow1)
    aCol[nCol  ] := ACLONE(aColRow2)
    oCol:DOWN()
    oCol:REFRESHALL()

  CASE (nKey == K_END .OR. nKey == K_CTRL_END .OR. ;
    nApply == TA_OUTBOX) .AND. YesNo('Save changes and exit?', .Y.)

    lSave   := .Y.
    lBrowse := .N.

  CASE (nKey == K_ESC .OR. nApply == TA_CLOSE) .AND. ;
    YesNo('Discard changes and exit?', .Y.)

    lSave   := .N.
    lBrowse := .N.

  END

  Sys()[SYS_CONTEXT] := nContext

END

IF lSave
  AEVAL(aHeading, {|cRow, nRow| aHeading[nRow] := ALLTRIM(cRow)})
  aReport[RP_HEADER  ] := ACLONE(aHeading)
  aReport[RP_COLUMNS ] := ACLONE(aCol)
  aReport[RP_GROUPS  ][1][RG_HEADER] := ALLTRIM(cGrpHead)
  aReport[RP_GROUPS  ][1][RG_TEXT  ] := ALLTRIM(cGrpExp)
  aReport[RP_SUMMARY ] := lGrpSum
  aReport[RP_GROUPS  ][1][RG_AEJECT] := lGrpEject
  aReport[RP_GROUPS  ][2][RG_HEADER] := ALLTRIM(cSubHead)
  aReport[RP_GROUPS  ][2][RG_TEXT  ] := ALLTRIM(cSubExp)
  aReport[RP_WIDTH   ] := nSetWidth
  aReport[RP_LMARGIN ] := nLMargin
  aReport[RP_RMARGIN ] := nRMargin
  aReport[RP_LINES   ] := nVLines
  aReport[RP_DBLSPACE] := lDouble
  aReport[RP_BEJECT  ] := lBEject
  aReport[RP_AEJECT  ] := lAEject
  aReport[RP_PLAIN   ] := lPlain
  aReport[RP_SUMMARY ] := lSummary
  WriteFRM(cFRMFile, aReport)
END

McRestBox(aSavBox)
RESTSCREEN(nBottom - 1, 2, nBottom, 77, cBottom)
SETCOLOR(cSavColor)
SETPOS(nSavRow, nSavCol)

RETURN  //  EditFRM

//***************************************************************************

PROCEDURE EditLBL(cLBLName)

/*

02----------------------------- MODIFY LABEL -------------------------------+
03                                                                          |
04 Parameters                                                               |
05                   Label width in characters ___                          |
06                       Label height in lines ___                          |
07                Number of labels across page ___                          |
08                                 Left margin ___                          |
09       Blank lines between labels vertically ___                          |
10    Blank spaces between labels horizontally ___                          |
11                                                                          |
12 Remark      ____________________________________________________________ |
13                                                                          |
14 Expressions ____________________________________________________________ |
15             ____________________________________________________________ |
16             ____________________________________________________________ |
17             ____________________________________________________________ |
18                                                                          |
19--------------------------------------------------------------------------+
20 Formats              List              END Save               ESC Cancel

02----------------------------- MODIFY LABEL -------------------------------+
03                                                                          |
04 Parameters                                                               |
05                   Label width in characters ___                          |
06                       Label height in lines ___                          |
07                Number of labels across page ___                          |
08                                 Left margin ___                          |
09       Blank lines between labels vertically ___                          |
10    Blank spaces between labels horizontally ___                          |
11                                                                          |
12 Remark      ____________________________________________________________ |
13                                                                          |
14 Expressions ____________________________________________________________ |
15             ____________________________________________________________ |
16             ____________________________________________________________ |
17             ____________________________________________________________ |
18             ____________________________________________________________ |
19             ____________________________________________________________ |
20             ____________________________________________________________ |
21             ____________________________________________________________ |
22             ____________________________________________________________ |
23             ____________________________________________________________ |
24             ____________________________________________________________ |
25             ____________________________________________________________ |
26             ____________________________________________________________ |
27             ____________________________________________________________ |
28             ____________________________________________________________ |
29             ____________________________________________________________ |
30             ____________________________________________________________ |
31             ____________________________________________________________ |
32             ____________________________________________________________ |
33             ____________________________________________________________ |
34             ____________________________________________________________ |
35             ____________________________________________________________ |
36             ____________________________________________________________ |
37             ____________________________________________________________ |
38             ____________________________________________________________ |
39             ____________________________________________________________ |
40             ____________________________________________________________ |
41             ____________________________________________________________ |
42             ____________________________________________________________ |
43                                                                          |
44--------------------------------------------------------------------------+
45 Formats              List              END Save               ESC Cancel

*/

STATIC cTextFile := '                                                            '
STATIC lAdditive := .Y.
STATIC lCodes    := .N.

LOCAL cSavColor  := SETCOLOR(Sys()[SYS_COLOR][DC_MVBROWSE])
LOCAL nSavRow    := ROW()
LOCAL nSavCol    := COL()
LOCAL nContext   := Sys()[SYS_CONTEXT]
LOCAL cLBLFile   := PathAdj(cLBLName,, '.LBL', .Y.)
LOCAL aLabel     := ReadLBL(cLBLFile, .N.)
LOCAL aField     := ACLONE(aLabel[LB_FIELDS])
LOCAL aLine      := {}
LOCAL nLine      := 1
LOCAL cLine      := SPACE(200)
LOCAL cRemark    := aLabel[LB_REMARK ]
LOCAL nWidth     := aLabel[LB_WIDTH  ]
LOCAL nHeight    := aLabel[LB_HEIGHT ]
LOCAL nAcross    := aLabel[LB_ACROSS ]
LOCAL nLMargin   := aLabel[LB_LMARGIN]
LOCAL nVSpace    := aLabel[LB_LINES  ]
LOCAL nHSpace    := aLabel[LB_SPACES ]
LOCAL nKey       := 0
LOCAL cKey       := ''
LOCAL nApply     := 0
LOCAL lBrowse    := .Y.
LOCAL lSave      := .N.
LOCAL lCalc      := .Y.
LOCAL lSayParam  := .Y.
LOCAL lSayRemark := .Y.
LOCAL nBottom    := MAXROW() - 4
LOCAL cBottom    := SAVESCREEN(nBottom, 2, nBottom, 77)
LOCAL aSavBox    := McBox({2, 2, nBottom - 1, 77}, cLBLFile)
LOCAL oLine      := TBROWSENEW(14, 16, nBottom - 2, 76)
LOCAL oCol       := NIL
LOCAL aFormat := { ;
  {'3.5 x 0.9375 x 1           ', 35, 5, 1, 0, 1, 0}, ;
  {'3.5 x 0.9375 x 2           ', 35, 5, 2, 0, 1, 2}, ;
  {'3.5 x 0.9375 x 3           ', 35, 5, 3, 0, 1, 2}, ;
  {'4   x 1.0625 x 1           ', 40, 8, 1, 0, 1, 0}, ;
  {'3.2 x 0.9167 x 3 (Cheshire)', 32, 5, 3, 0, 1, 2}  }
LOCAL aFormChoice := {}
LOCAL nFormChoice := 0
LOCAL aKeyPad := { ;
  { 4     ,  4, 10     , 75, 'P'        , .Y., 'P'     , 'arameters'  }, ;
  {12     ,  4, 12     , 75, 'R'        , .Y., 'R'     , 'emark'      }, ;
  {14     ,  4, 19     , 75, 'E'        , .Y., 'E'     , 'xpressions' }, ;
  {nBottom,  4, nBottom, 10, 'F'        , .Y., 'F'     , 'ormats'     }, ;
  {nBottom, 25, nBottom, 28, 'L'        , .Y., 'L'     , 'ist'        }, ;
  {nBottom, 43, nBottom, 50, K_END      , .Y., 'END '  , 'Save'       }, ;
  {nBottom, 66, nBottom, 75, K_ESC      , .Y., 'ESC '  , 'Cancel'     }  }

@  5,  7 SAY '               Label width in characters'
@  6,  7 SAY '                   Label height in lines'
@  7,  7 SAY '            Number of labels across page'
@  8,  7 SAY '                             Left margin'
@  9,  7 SAY '   Blank lines between labels vertically'
@ 10,  7 SAY 'Blank spaces between labels horizontally'
@ nBottom, 2 CLEAR TO nBottom, 77
SayInitial(aKeyPad)

AEVAL(aFormat, {|aRow| AADD(aFormChoice, aRow[1])})
AEVAL(aField, {|aRow| AADD(aLine, aRow[LF_TEXT])})

oCol := TBCOLUMNNEW('', {|| IF(EMPTY(aLine), '', aLine[nLine])})
oCol:WIDTH := 60
oLine:ADDCOLUMN(oCol)
oLine:GOTOPBLOCK    := {|| nLine := 1}
oLine:GOBOTTOMBLOCK := {|| nLine := MAX(1, LEN(aLine))}
oLine:SKIPBLOCK     := {|nSkip, nLineOld| nLineOld := nLine, ;
  (nLine := MAX(MIN(nLine + nSkip, LEN(aLine)), 1)) - nLineOld}

WHILE lBrowse

  IF lCalc
    ASIZE(aLine, nHeight)
    AEVAL(aLine, {|cRow, nRow| ;
      aLine[nRow] := PADR(IF(cRow == NIL, '', cRow), 60)})
    oLine:REFRESHALL()
    cRemark    := PADR(cRemark, 60)
    lSayParam  := .Y.
    lSayRemark := .Y.
  END

  IF lSayParam
    COLORSELECT(3)
    @  5, 48 SAY TRANSFORM(nWidth  , '999')
    @  6, 48 SAY TRANSFORM(nHeight , '999')
    @  7, 48 SAY TRANSFORM(nAcross , '999')
    @  8, 48 SAY TRANSFORM(nLMargin, '999')
    @  9, 48 SAY TRANSFORM(nVSpace , '999')
    @ 10, 48 SAY TRANSFORM(nHSpace , '999')
    COLORSELECT(0)
    lSayParam := .N.
  END

  IF lSayRemark
    COLORSELECT(3)
    @ 12, 16 SAY PADR(cRemark, 60)
    COLORSELECT(0)
    lSayRemark := .N.
  END

  CenterStable(oLine, {4, 4, 1, 2})
  nKey   := McTransPad(aKeyPad, INKEY(0))
  cKey   := UPPER(CHR(nKey))
  nApply := McTBApplyKey(oLine, nKey)

  DO CASE
  CASE cKey == 'P'

    Sys()[SYS_CONTEXT] := H_LBLPARAM
    BoxGet('LABEL PARAMETERS',, { ;
      {'Label width in characters:'               , ;
      nWidth  , {|nVal| nWidth   := nVal}, '999'}, ;
      {'Label height in lines:'                   , ;
      nHeight , {|nVal| nHeight  := nVal}, '999'}, ;
      {'Number of labels across page:'            , ;
      nAcross , {|nVal| nAcross  := nVal}, '999'}, ;
      {'Left margin:'                             , ;
      nLMargin, {|nVal| nLMargin := nVal}, '999'}, ;
      {'Vert. lines between labels:'   , ;
      nVSpace , {|nVal| nVSpace  := nVal}, '999'}, ;
      {'Horiz. spaces between labels:', ;
      nHSpace , {|nVal| nHSpace  := nVal}, '999'}})
    lCalc := .Y.

  CASE cKey == 'R'

    Sys()[SYS_CONTEXT] := H_LBLREMARK
    BoxGet('LABEL REMARK',, { ;
      {'Remark:', cRemark, {|cVal| cRemark := cVal}, '@S60'}})
    lSayRemark := .Y.

  CASE cKey == 'E'

    Sys()[SYS_CONTEXT] := H_LBLLINE
    BoxGet('EDIT LABEL LINE EXPRESSIONS', BT_STRUC, { ;
      {'Expressions:', aLine, {|aVal| aLine := ACLONE(aVal)}, '@S60'}})
    oLine:REFRESHALL()

  CASE cKey == 'F'

    Sys()[SYS_CONTEXT] := H_LBLFORM
    nFormChoice := KeyChoice('LABEL FORMATS', .Y., aFormChoice)
    IF !EMPTY(nFormChoice)
      nWidth   := aFormat[nFormChoice][2]
      nHeight  := aFormat[nFormChoice][3]
      nAcross  := aFormat[nFormChoice][4]
      nLMargin := aFormat[nFormChoice][5]
      nVSpace  := aFormat[nFormChoice][6]
      nHSpace  := aFormat[nFormChoice][7]
      cRemark  := IF(EMPTY(cRemark), '', RTRIM(cRemark) + ' ') + ;
        aFormat[nFormChoice][1]
      lCalc    := .Y.
    END

  CASE cKey == 'L'

    Sys()[SYS_CONTEXT] := H_LBLLIST
    BoxGet('LIST LABEL FILE',, { ;
      {'To:', cTextFile, {|cVal| cTextFile := cVal}, '@F', '.TXT'}, ;
      {'Additive:', lAdditive, {|lVal| lAdditive := lVal}}, ;
      {'Printer codes:', lCodes, {|lVal| lCodes := lVal}}})
    IF EMPTY(cTextFile) .OR. LASTKEY() == K_ESC
      BREAK
    END
    PrintInit(lCodes)
    BoxStatus('Listing...')
    PrintSet(.Y., cTextFile, lAdditive)
    BEGIN SEQUENCE
      QQOUT(PrintCodes(lCodes, .Y.))
      QQOUT(ListLBL(cLBLFile, aLine, cRemark, nWidth, nHeight, nAcross, ;
        nLMargin, nVSpace, nHSpace))
      QQOUT(PrintCodes(lCodes, .N.))
    END SEQUENCE
    PrintSet(.N.)
    BoxStatus()

  CASE (nKey == K_END .OR. nKey == K_CTRL_END .OR. ;
    nApply == TA_OUTBOX) .AND. YesNo('Save changes and exit?', .Y.)

    lSave   := .Y.
    lBrowse := .N.

  CASE (nKey == K_ESC .OR. nApply == TA_CLOSE) .AND. ;
    YesNo('Discard changes and exit?', .Y.)

    lSave   := .N.
    lBrowse := .N.

  END

  Sys()[SYS_CONTEXT] := nContext

END

IF lSave
  ASIZE(aField, LEN(aLine))
  FOR nLine := 1 TO LEN(aLine)
    aField[nLine]          := ARRAY(LF_COUNT)
    aField[nLine][LF_TEXT] := aLine[nLine]
  NEXT
  aLabel[LB_FIELDS ] := ACLONE(aField)
  aLabel[LB_REMARK ] := cRemark
  aLabel[LB_WIDTH  ] := nWidth
  aLabel[LB_HEIGHT ] := nHeight
  aLabel[LB_ACROSS ] := nAcross
  aLabel[LB_LMARGIN] := nLMargin
  aLabel[LB_LINES  ] := nVSpace
  aLabel[LB_SPACES ] := nHSpace
  WriteLBL(cLBLFile, aLabel)
END

McRestBox(aSavBox)
RESTSCREEN(nBottom, 2, nBottom, 77, cBottom)
SETCOLOR(cSavColor)
SETPOS(nSavRow, nSavCol)

RETURN  //  EditLBL