;*  
;*  exe_path.asm  Written by Terry Carmen on 8/23/1991
;*  
;*  [1] Who am I? 
;*  [2] What am I doing here? 
;*  [3] What's the meaning of life?
;*  
;*  Answering question 3 requires a philosopher
;*  Answering question 2 requires a debugger
;*  Answering question 1 only requires this program
;*  
;*  Well, 1 out of 3 isn't bad....
;*  
;*  This program returns the complete path and filename of your 
;*  Clipper program, ie. "e:\clipper\work\TEST.EXE"
;*  
;*  File requestable as exe_path at 1:260/338@fidonet 
;*  23 hours, 300-38,400 baud
;*  
;*  Released to the public domain.               
;*  
;*  If it breaks in two, you get to keep both halves
;*  
;*  Compile with TASM (and probably MASM)
;*  with the /mu flag, and link with your         
;*  Clipper program                              
;*                                               
;*  Usage: path=exe_path()
;*  
;*  Note: This program uses a DOS function call that was unreliable in 
;*  DOS version 3.0 and earlier.




public  exe_path
        
extrn   __retc:far         ; return a string

ENV_SEG_ADDR_OFFSET  EQU  2Ch

dgroup  group   datasg
datasg  segment public  '_DATA'
assume cs:_prog, ds:dgroup, es:nothing

bad_path db 0

datasg  ends

_prog   segment 'CODE'


exe_path        proc    far

                push    bp         
                mov     bp,sp     
                push    si
                push    di

                mov     ah, 51h
                int     21h               ; BX now contains segment for PSP
                mov     es, bx           

                mov     si, ENV_SEG_ADDR_OFFSET    ; offset of address of env. block
                mov     ax, es:[si]
                mov     es, ax            ; ES now contains the segment for 
                                          ; the environment for this process

                xor     si, si            ; zero the SI register

@@next_char:    cmp si, 32767
                je @@bug_out              ; this will never execute 
                                          ; unless the environment 
                                          ; is trashed

                cmp byte ptr es:[si],0    ; did we find a null?
                je @@try_second_zero      ; yes, look for another 
                inc si                    ; no, 
                jmp @@next_char           ; look at next char

@@try_second_zero:                        
                inc si                    ; point to next char
                cmp byte ptr es:[si],0    ; is it a second zero?
                jne @@next_char           ; it was only a single
                                          ; zero, so it was probably 
                                          ; just the end of a line

                ; we found the end of the environment

                inc si                    ; skip over the next 3 bytes
                inc si                       
                inc si                       

                ; at this point, we're pointing to the beginning of the 
                ; full path and filename of the currently executing program.

                jmp short @@bye

@@bug_out:      mov    ax, ds                 ; if we blew up, point to our
                mov    es, ax                 ; null, so we can 
                mov    si, offset bad_path    ; send back nothing
                
@@bye:          mov    ax, es                 ; point to seg for
                mov    bx, si                 ; return string

                push   ax                    
                push   bx                 

                call   __retc
                add    sp,4

                pop     di
                pop     si
                pop     bp
                ret                              ; far return to Clipper
                
exe_path        endp
_prog           ends
                end



