/* ---------------------------------------------------------------------------

   MTEST.PRG      Demonstration program for MouseLib

   Written by Steve Forbes  Clipper User Group Melbourne

   Compile:       Clipper MTEST /w

   ------------------------------------------------------------------------ */

#include "Box.ch"
#include "SetCurs.ch"
#include "Mouse.ch"

#command REPEAT => DO WHILE .T.

#command UNTIL <expL> => IF( <expL> ); EXIT; END; END

LOCAL nStatus := 0,     ;
      nButtons := 0,    ;
      nRow := 0,        ;
      nCol := 0,        ;
      nHorz := 0,       ;
      nVert := 0,       ;
      nThresh := 0,     ;
      nLeftb := 0,      ;
      nRightb := 0,     ;
      nMiddleb := 0,    ;
      nPresses := 0,    ;
      nReleases := 0,   ;
      nSize := 0,       ;
      nKey,             ;
      cBuffer,          ;
      nPage,            ;
      nPage2

// Turn the text cursor off
SETCURSOR( SC_NONE )

SETCOLOR( "W+/B" )
CLS

//@ 1, 1, 22, 78 BOX B_DOUBLE_TOP

SETCOLOR( "BG/B" )

@ 0, 1 SAY PADR( "MouseReset() demo", 78 )

MouseReset( @nStatus, @nButtons )

@ 3, 4 SAY "Syntax: MouseReset( @nStatus, @nButtons )"
@ 5, 4 SAY "A Mouse " + IF( nStatus == -1, "IS", "IS NOT" ) + " present"
?? IF( nStatus == -1, " and has " + STR( nButtons, 1 ) + " buttons.", ". Aborting demonstration!" )

IF nStatus == - 1

   MouseWait( "Press any mouse button or key to move to next demo " )

   CleanDesk()

   @ 0, 1 SAY PADR( "MouseSeen() demo", 78 )

   @ 3, 4 SAY "Syntax: IF MouseSeen()"

   MouseHide()

   IF MouseSeen()
      @ 5, 4 SAY "The Mouse cursor is visible           "
   ELSE
      @ 5, 4 SAY "The Mouse cursor is NOT visible       "
   ENDIF

   MouseWait( "Press any mouse button or key to make the mouse cursor visible" )

   MouseShow()

   IF MouseSeen()
      @ 7, 4 SAY "The Mouse cursor is visible now      "
   ELSE
      @ 7, 4 SAY "The Mouse cursor is still NOT visible"
   ENDIF

   MouseWait( "Press any mouse button to continue ... " )

   CleanDesk()

   @  0,  1 SAY "MouseKey() demo          "

   @ 3, 4 SAY "Syntax:    nKey = MouseKey( nButton )"
   @ 5, 4 SAY "This call: nKey = MouseKey( LBUTTON )"

   MouseWait( "Press left mouse button to continue ... ", LBUTTON )

   @ 5, 4 SAY "This call: nKey = MouseKey( RBUTTON )"

   MouseWait( "Press right mouse button to continue ... ", RBUTTON )

   @ 5, 4 SAY "This call: nKey = MouseKey( ALLBUTTON )"

   MouseWait( "Press any mouse button to continue ... " )

   IF nButtons == 3

      INKEY( .4 )

      @ 5, 4 SAY "This call: nKey = MouseKey( MBUTTON )  "

      MouseWait( "Press middle mouse button to move to next demo ...", MBUTTON )

   ENDIF

   CleanDesk()
   @ 24,  0 SAY SPACE(80)

   @ 0, 1 SAY PADR( "MouseState() demo          ", 78 )
   @ 24,  1 SAY "Click Quit for next demo"
   @ 24, 32 SAY "Left:    Right:    Middle:    Row:     Col:"

   SETCOLOR( "GR+/R" )
   @ 3, 5 SAY " Quit "
   SETCOLOR( "BG/B" )

   MousePut( 2, 2 )
   MouseArea( 2, 2, 21, 77 )
   MouseShow()

   REPEAT
      MouseState( @nLeftb, @nRightb, @nMiddleb, @nRow, @nCol )
      WhereMouse( nLeftb, nRightb, nMiddleb, nRow, nCol )
   UNTIL ( MouseInBox( 3, 5, 3, 10, @nLeftb, @nRightb, @nMiddleb ) .AND. nLeftb == 1 )

   CleanDesk()

   // Mouse can travel anywhere
   MouseArea( 0, 0, 24, 79 )

   @ 24,  0 SAY SPACE(80)

   @ 0, 1 SAY PADR( "MousePut() demo", 78 )

   FOR nRow = 2 TO 21
      nCol := nRow
      MousePut( nRow, nCol * 3 )
      INKEY( .1 )
   NEXT

   MouseWait( "Press right mouse button to continue ... ", RBUTTON )

   MousePut( 1, 1 )

   @ 0, 1 SAY PADR( "MousePress() demo", 78 )

   @ 3, 4 SAY "Ŀ"
   @ 4, 4 SAY " Button          Status  Presses  Row  Col "
   @ 5, 4 SAY "Ĵ"
   @ 6, 4 SAY " Left Button                               "
   @ 7, 4 SAY " Middle Button                             "
   @ 8, 4 SAY " Right Button                              "
   @ 9, 4 SAY ""

   @ 24,  1 SAY  PADR( "Press right mouse button @ 0, 0 to continue ... ", 78 )

   DO WHILE !( nRow == 0 .AND. nCol == 0 )
      MousePress( LBUTTON, @nLeftb, @nPresses, @nRow, @nCol )
      @ 6, 26 SAY STR( nLeftb, 1 )
      @ 6, 35 SAY STR( nPresses, 1 )
      @ 6, 43 SAY STR( nRow, 2 )
      @ 6, 49 SAY STR( nCol, 2 )
      MousePress( MBUTTON, @nMiddleb, @nPresses, @nRow, @nCol )
      @ 7, 26 SAY STR( nMiddleb, 1 )
      @ 7, 35 SAY STR( nPresses, 1 )
      @ 7, 43 SAY STR( nRow, 2 )
      @ 7, 49 SAY STR( nCol, 2 )
      MousePress( RBUTTON, @nRightb, @nPresses, @nRow, @nCol )
      @ 8, 26 SAY STR( nRightb, 1 )
      @ 8, 35 SAY STR( nPresses, 1 )
      @ 8, 43 SAY STR( nRow, 2 )
      @ 8, 49 SAY STR( nCol, 2 )
      INKEY( .4 )
   ENDDO

   @ 4, 4 SAY " Button          Status  Releases Row  Col "
   @ 24,  1 SAY  PADR( "Press right mouse button @ 0, 79 to continue ... ", 78 )

   @ 0, 1 SAY PADR( "MouseRel() demo", 78 )

   DO WHILE !( nRow == 0 .AND. nCol == 79 )
      MouseRel( LBUTTON, @nLeftb, @nReleases, @nRow, @nCol )
      @ 6, 26 SAY STR( nLeftb, 1 )
      @ 6, 35 SAY STR( nReleases, 1 )
      @ 6, 43 SAY STR( nRow, 2 )
      @ 6, 49 SAY STR( nCol, 2 )
      MouseRel( MBUTTON, @nMiddleb, @nReleases, @nRow, @nCol )
      @ 7, 26 SAY STR( nMiddleb, 1 )
      @ 7, 35 SAY STR( nReleases, 1 )
      @ 7, 43 SAY STR( nRow, 2 )
      @ 7, 49 SAY STR( nCol, 2 )
      MouseRel( RBUTTON, @nRightb, @nReleases, @nRow, @nCol )
      @ 8, 26 SAY STR( nRightb, 1 )
      @ 8, 35 SAY STR( nReleases, 1 )
      @ 8, 43 SAY STR( nRow, 2 )
      @ 8, 49 SAY STR( nCol, 2 )
      INKEY( .4 )
   ENDDO

   CleanDesk()

   @ 24,  1 SAY  PADR( "Press any mouse button or key to move to next demo ", 78 )

   MouseArea( 2, 2, 21, 77 )

   @ 0, 1 SAY PADR( "MouseMoves() demo", 78 )

   @ 3, 4 SAY "Syntax:    MouseMoves( @nRow, @nCol )"

   nPresses = 0
   DO WHILE ( !( IsButton( ALLBUTTON ) ) )
      MouseMoves( @nRow, @nCol )
      @ 5, 4 SAY "Vertical Mickeys:   "
      ?? nRow
      @ 7, 4 SAY "Horizontal Mickeys: "
      ?? nCol
      INKEY(.1)
   ENDDO

   CleanDesk()

   @ 0, 1 SAY PADR( "MouseStore() demo", 78 )

   @ 3, 4 SAY "Syntax:    MouseStore( @nSize )"

   MouseStore( @nSize )
   @ 5, 4 SAY "Storage buffer required:  SPACE("
   ?? LTRIM( STR( nSize ) )
   ?? ")"
   cBuffer := SPACE( nSize )
   MouseSave( @cBuffer )

   SETCOLOR( "BG/B" )

   @ 24,  1 SAY  PADR( "Press any key to continue ... ", 78 )

   INKEY( 0 )

   @ 0, 1 SAY PADR( "MiceRatio() demo", 78 )
   MouseReset( @nStatus, @nButtons )
   MouseShow()
   MouseRatio( 32, 64 )

   @ 3, 4 SAY "This call:  MouseRatio( 32, 64 )               "
   @ 5, 4 SAY  SPACE(60)

   MouseWait( "Press any mouse button to continue ... " )

   MouseRatio( 4, 8 )
   @ 3, 4 SAY "This call:  MouseRatio( 4, 8 )                   "

   MouseWait( "Press any mouse button to continue ... " )

   @ 0, 1 SAY PADR( "MouseRest() demo", 78 )

   @ 3, 4 SAY "Syntax:    MouseRest( cBuffer )"

   // Turn mouse off before writing to, or clearing the screen
   MouseHide()

   MouseRest( cBuffer )

   INKEY( 1 )

   MouseWait( "Press any mouse button to continue ... " )

   CleanDesk()
   @ 0, 1 SAY PADR( "MouseTCurs() demo", 78 )

   @ 3, 4 SAY "This call:    MouseTCurs( HARD_TEXT_CURSOR, 3, 7 )"

   MouseTCurs( HARD_TEXT_CURSOR, 3, 7 )

   MouseWait( "Press any mouse button to continue ... " )

   SET CURSOR OFF

   @ 3, 4 SAY "This call:    MouseTCurs( SOFT_TEXT_CURSOR, 4660, 30292 )"

   MouseTCurs( SOFT_TEXT_CURSOR, 4660, 30292 )

   MouseWait( "Press any mouse button to continue ... " )

   @ 3, 4 SAY "This call:    MouseTCurs( SOFT_TEXT_CURSOR, 65535, 30464 )"

   MouseTCurs( SOFT_TEXT_CURSOR, 65535, 30464 )

   MouseWait( "Press any mouse button to continue ... " )

   CleanDesk()

   @ 0, 1 SAY PADR( "MouseGetPg() demo", 78 )

   @ 3, 4 SAY "Syntax:    MouseGetPg( @<expN> )"

   MouseGetPg( @nPage )
   @ 5, 4 SAY "The mouse cursor is currently visible on page #"
   ?? nPage

   MouseWait( "Press any mouse button to continue ... " )

   @ 7, 4 SAY "Now lets put the mouse cursor on the next page!"

   MouseSetPg( nPage + 1 )

   MouseGetPg( @nPage2 )

   @ 9, 4 SAY "The mouse cursor is now on page #"
   ?? nPage2

   MouseWait( "Press any mouse button to continue ... " )

   MouseSetPg( nPage )

   CleanDesk()

   @ 0, 1 SAY PADR( "MouseDbl() demo", 78 )

   @ 3, 4 SAY "Syntax:    MouseDbl( <expN> )"

   @ 5, 4 SAY "This call:  MouseDbl( 9999 )"
   MouseDbl( 9999 )

   MouseWait( "Press any mouse button to continue ... " )

   @ 7, 4 SAY "This call:  MouseDbl( 1 )"
   MouseDbl( 1 )

   MouseWait( "Press any mouse button to continue ... " )

   @ 9, 4 SAY "This call:  MouseDbl( 64 )"
   MouseDbl( 64 )

   MouseWait( "Press any mouse button to continue ... " )

   @ 0, 1 SAY PADR( "MouseGetSn() demo", 78 )

   @ 3, 4 SAY "Syntax:  MouseGetSn( @nVert, @nHorz, @nThresh )"

   MouseGetSn( @nVert, @nHorz, @nThresh )
   @ 5, 4 SAY "Vertical Sensitivity:   "
   ?? nVert
   @ 7, 4 SAY "Horizontal Sensitivity: "
   ?? nHorz
   @ 9, 4 SAY "Double Speed Threshold: "
   ?? nThresh

   MouseWait( "Press any mouse button to continue ... " )

   CleanDesk()

   @ 0, 1 SAY PADR( "MouseSetSn() demo", 78 )

   @ 3, 4 SAY "This call:  MouseSetSn( 90, 90, 10 )"
   MouseSetSn( 90, 90, 10 )

   MouseGetSn( @nVert, @nHorz, @nThresh )
   @ 6, 4 SAY "Vertical Sensitivity now:   "
   ?? nVert
   @ 8, 4 SAY "Horizontal Sensitivity now: "
   ?? nHorz
   @ 10, 4 SAY "Double Speed Threshold now: "
   ?? nThresh

   MouseWait( "Press any mouse button to finish demonstration ... " )

ENDIF
SETCOLOR( "" )
MouseHide()
CLS
RETURN

// ----------------------------------------------------------------------------

FUNCTION WhereMouse ( nLeftb, nRightb, nMiddleb, nRow, nCol )
@ 24, 38 SAY STR( nLeftb, 1 )
@ 24, 48 SAY STR( nRightb, 1 )
@ 24, 59 SAY STR( nMiddleb, 1 )
@ 24, 67 SAY STR( nRow, 2 )
@ 24, 76 SAY STR( nCol, 2 )
RETURN( NIL )

// ----------------------------------------------------------------------------

FUNCTION CleanDesk

// Turn mouse off before writing to, or clearing the screen
MouseHide()

@ 2, 2 CLEAR TO 21, 77

// Now show it again
MouseShow()

RETURN( NIL )

// ----------------------------------------------------------------------------

FUNCTION MouseWait ( cPrompt, nButton )

LOCAL nKey

nButton := IF( nButton == NIL, ALLBUTTON, nButton )

@ 24,  1 SAY  PADR( cPrompt, 78 )

nKey = MouseKey( nButton )

INKEY( .4 )

RETURN ( NIL )

